:userdoc.
:docprof toc=123456.
:title.Harbour Reference Guide
.* HBDOC generated IPF Source File.
.* HBDOC Document Source Extractor, (c)1999-2000 Luiz Rafael Culik.
:h1 ARRAY.ARRAY
:h2  res=1.ARRAY()
:i1 id=ARRAYX.ARRAY
:i2 refid=ARRAYX.ARRAY()
:p.ARRAY&lpar.&rpar.
.br
.br
:hp2.Crea un array sin inicializar de la longitud especificada:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.ARRAY&lpar. <nElementos> &lbrk.&comma. <nElementos>...&rbrk.. &rpar. &minus.&minus.> aArray:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<nElementos> es el nmero de elementos de la dimensin especificada.
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.Un array con las dimensiones especificadas.
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin retorna un array sin inicializar de longitud <nElementos>.  Si parmetros <nElementos> adicionales son especificados se crea  un array anidado multidimensional sin inicializar dentro de la misma  referencia del
array.  Crear una variable de memoria con el mismo nombre que el array puede  destruir el array original y liberar el contenido entero del array.  Esto depende&comma. por supuesto del tipo de almacenamiento de ambos&colon. del
array y la variable con el mismo nombre que el array.
.br
.br
:hp2.Examples:ehp2.
.br
:p.
:lm margin=6.
.br
      *  El siguiente ejemplo crea un array de diez elementos iniciales&comma.
.br
         luego en cada elemento de ese array&comma. va creando submatrices
.br
         lineales con la funcin ARRAY&lpar.&rpar.. Cada una con la misma cantidad
.br
         de items que la posicin que ocupa en aArray. Finalmente lo muestra.
.br

.br
         LOCAL aArray &colon.&eq. Array&lpar.10&rpar.
.br
         LOCAL i &colon.&eq. 1&comma. j
.br

.br
         FOR i &eq. 1 to LEN&lpar. aArray &rpar.
.br
           aArray &lbrk.i&rbrk.. &colon.&eq. Array&lpar.i&rpar.
.br
         NEXT
.br

.br
         FOR i &eq. 1 to LEN&lpar. aArray &rpar.
.br
            ? i
.br
            FOR j &eq. 1 to LEN&lpar. aArray &lbrk.i&rbrk.. &rpar.
.br
                ?? &cdq. &cdq.&comma. aArray &lbrk.i&rbrk..&lbrk.j&rbrk..
.br
            NEXT
.br
         NEXT
.br

.br
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin es CA&minus.CLIPPER Compatible en todos los casos&comma. excepto que  los arrays en Harbour pueden tener un nmero ilimitado de elementos  mientras que Clipper tiene un lmite de 4096 elementos por dimensin.  Los
arrays en Harbour pueden tener un nmero ilimitado de dimensiones.
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.El cdigo fuente est en arrays.c  La librera asociada es vm
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=2.AADD():elink.
.br
:link reftype=hd res=3.ADEL():elink.
.br
:link reftype=hd res=4.AFILL():elink.
.br
:link reftype=hd res=5.AINS():elink.
.br
:h2 id=ARRAY res=2.AADD()
:i2 refid=ARRAYX.AADD()
:p.AADD&lpar.&rpar.
.br
.br
:hp2.Agrega dinmicamente un nuevo elemento al final de un array:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.AADD&lpar.<aDestino>&comma. <xValor>&rpar. &minus.&minus.> Valor:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<aDestino> es el array al cual se agrega un nuevo elemento.
.br
:p.<xValor> es el valor asignado al nuevo elemento.
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.AADD&lpar.&rpar. evala <xValor> y retorna su valor.  Si <xValor> no esta  especificado&comma. AADD&lpar.&rpar. retorna NIL.
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.AADD&lpar.&rpar. es una funcin que dinmicamente incrementa la longitud actual del  array destino en un elemento y asigna el valor <xValor> al recin creado  elemento del array.  <xValor> puede ser un puntero de referencia a
otro array&comma. el cual puede  ser asignado a la posicion subindice.
.br
:p.Es til para construir listas dinmicas o colas &lpar.queues&rpar..  Cada vez que se ejecuta un comando @...GET&comma. el sistema usa AADD&lpar.&rpar. para  agregar un nuevo elemento al final del array GetList&comma. y entonces
asignar  un nuevo objeto Get al nuevo elemento.
.br
.br
:hp2.Examples:ehp2.
.br
:p.
:lm margin=6.
.br
   *  Este ejemplo muestra el efecto de mltiples llamadas de la funcin
.br
      AADD&lpar.&rpar. a un array&comma. donde va agrgando un nuevo elemento cada vez.
.br

.br
      LOCAL aArray &colon.&eq. &lbrc.&rbrc.
.br
      FOR x&colon.&eq. 1 to 10
.br
          AADD&lpar. aArray&comma. x&rpar.
.br
      NEXT
.br

.br
   *  Este ejemplo crea un array multidemensional
.br
      LOCAL aArray &colon.&eq. &lbrc.&rbrc.              &slash.&slash. Resultado&colon. aArray es un array vaco
.br
      AADD&lpar. aArray&comma. &lbrc.10&comma. 10122734 &rbrc.&rpar.  &slash.&slash. Resultado&colon. aArray es &lbrc.10&comma. 10122734&rbrc.
.br
      AADD&lpar. aArray&comma. &lbrc.11&comma. 13173645 &rbrc.&rpar.  &slash.&slash. Resultado&colon. aArray es
.br
                                     &lbrc. &lbrc. 10&comma. 10122734 &rbrc.&comma. &lbrc. 11&comma. 13173645 &rbrc. &rbrc.
.br
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin es totalmente compatible con CA&minus.Clipper.
.br
.br
:hp2.Platforms:ehp2.
.br
:p.
:lm margin=6.
:p.Todas las plataformas
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.El cdigo fuente est en arrays.c  La librera asociada es vm
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=5.AINS():elink.
.br
:link reftype=hd res=6. ASIZE():elink.
.br
:h2 id=ARRAY res=7.ASIZE()
:i2 refid=ARRAYX.ASIZE()
:p.ASIZE&lpar.&rpar.
.br
.br
:hp2.Ajusta &lpar.aumenta  decrementa&rpar. el tamao de un array:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.ASIZE&lpar.<aDestino>&comma. <nLongitud>&rpar. &minus.&minus.> aDestino:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<aDestino> es el nombre del array a ser dinmicamente alterado
.br
:p.<nLongitud> es el valor Numrico del nuevo tamao de <aDestino>
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.ASIZE&lpar.&rpar. retorna una referencia al array <aDestino>.
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin dinmicamente incrementa  decrementa el tamao del array  <aDestino> ajustando la longitud del array a <nLongitud> posiciones.
.br
:p.Si la longitud del array <aDestino> is acortada&comma. aquellos elementos  al final se pierden. Si la longitud del array es alargada un valor NIL  es asignado a los elementos en las nuevas posiciones.
.br
.br
:hp2.Examples:ehp2.
.br
:p.
:lm margin=6.
.br
      *  El siguiente ejemplo crea un array con un slo elemento&comma. luego lo
.br
         agranda y luego lo vuelve al tamao original.
.br

.br
         aArray &colon.&eq. &lbrc. 1 &rbrc.           &slash.&slash. Resultado&colon. aArray es &lbrc. 1 &rbrc.
.br
         ASIZE&lpar. aArray&comma. 3&rpar.         &slash.&slash. Resultado&colon. aArray es &lbrc. 1&comma. NIL&comma. NIL &rbrc.
.br
         ASIZE&lpar. aArray&comma. 1&rpar.         &slash.&slash. Resultado&colon. aArray es &lbrc. 1 &rbrc.
.br
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.Si HB&us.COMPAT&us.C53 es definido&comma. la funcin genera un Error&comma. de otro  modo retornar el mismo array.
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.El cdigo fuente est en arrays.c  La librera asociada es vm
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=2.AADD():elink.
.br
:link reftype=hd res=8. ADEL():elink.
.br
:link reftype=hd res=9. AFILL():elink.
.br
:link reftype=hd res=10. AINS():elink.
.br
:h2 id=ARRAY res=11.ATAIL()
:i2 refid=ARRAYX.ATAIL()
:p.ATAIL&lpar.&rpar.
.br
.br
:hp2.Retorna el ltimo elemento de un array:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.ATAIL&lpar. <aArray> &rpar. &minus.&minus.> Elemento:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<aArray> es el nombre del array a usar
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.ATAIL&lpar.&rpar. retorna <Elemento> que puede ser un valor  una referencia  contenida en el ltimo elemento en el array.
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin devuelve el ltimo elemento en el array llamado <aArray>.  No modifica el tamao del array ni el valor de ningn subndice.
.br
.br
:hp2.Examples:ehp2.
.br
:p.
:lm margin=6.
.br
      *  El siguiente ejemplo crea un array unidimensional y devuelve el
.br
         ltimo elemento.
.br

.br
         aArray &colon.&eq. &lbrc. &cdq.Cul&cdq.&comma. &cdq.es el&cdq.&comma. &cdq.futuro&cdq.&comma. &cdq.de xBase ?&cdq.&comma. &cdq.Harbour!&cdq. &rbrc.
.br
         ? ATAIL&lpar. aArray &rpar.
.br
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin es totalmente compatible con CA&minus.Clipper.
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.El cdigo fuente est en arrays.c  La librera asociada es vm
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=12.LEN():elink.
.br
:link reftype=hd res=1.ARRAY():elink.
.br
:link reftype=hd res=7.ASIZE():elink.
.br
:link reftype=hd res=2.AADD():elink.
.br
:h2 id=ARRAY res=5.AINS()
:i2 refid=ARRAYX.AINS()
:p.AINS&lpar.&rpar.
.br
.br
:hp2.Inserta un elemento NIL en una posicin del array:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.AINS&lpar. <aArray>&comma. <nPos> &rpar. &minus.&minus.> aDestino:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<aArray> es el nombre del array al que se va a insertar un item
.br
:p.<nPos> es la posicin en el <aArray>
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.AINS&lpar.&rpar. retorna una referencia al array destino&comma. <aDestino>
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin inserta un valor NIL en el array llamado <aArray>  en la posicion <nPos>.
.br
:p.Todos los elementos del array comenzando con la <nPos> sern  desplazados hacia arriba una posicin y el ltimo item en el array  ser removido completamente. En otras palabras&comma. si se va a insertar un  item en la quinta
posicin de un array de diez elementos&comma. el elemento  que previamente estaba en la quinta posicin ahora ser reubicado a  la sexta posicin. El elemento recin agregado ser de tipo NIL y el  ltimo elemento es descartado.
La longitud del array <aArray>  permanece sin cambios.
.br
.br
:hp2.Examples:ehp2.
.br
:p.
:lm margin=6.
.br
      *  El siguiente ejemplo crea un array lineal&comma. al cual se inserta un
.br
         elemento en la quinta posicin&comma. perdindose el ltimo.
.br

.br
         LOCAL aArray&colon.&eq. &lbrc. 1&comma. 2&comma. 3&comma. 4&comma. 5&comma. 6&comma. 7&comma. 8&comma. 9&comma. 10 &rbrc.
.br
         AINS&lpar. aArray&comma. 5&rpar.
.br

.br
         Resultado&colon. aArray es &lbrc. 1&comma. 2&comma. 3&comma. 4&comma. NIL&comma. 5&comma. 6&comma. 7&comma. 8&comma. 9 &rbrc.
.br
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin es totalmente compatible con CA&minus.Clipper.
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.El cdigo fuente est en arrays.c  La librera asociada es vm
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=2.AADD():elink.
.br
:link reftype=hd res=13. ACOPY():elink.
.br
:link reftype=hd res=8. ADEL():elink.
.br
:link reftype=hd res=14. AEVAL():elink.
.br
:link reftype=hd res=9. AFILL():elink.
.br
:link reftype=hd res=6. ASIZE():elink.
.br
:h2 id=ARRAY res=3.ADEL()
:i2 refid=ARRAYX.ADEL()
:p.ADEL&lpar.&rpar.
.br
.br
:hp2.Borra un elemento del array:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.ADEL&lpar.<aDestino>&comma. <nPos>&rpar. &minus.&minus.> aDestino:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<aDestino> es el nombre del array cuyo elemento ser removido.
.br
:p.<nPos>  es la posicin del elemento a borrar
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.ADEL&lpar.&rpar. retorna una referencia al array destino&comma. <aDestino>
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin borra el elemento que se encuentra en la posicin <nPos>  en el array <aDestino>. Todos los elementos en el array <aDestino>  ms all de la posicin dada <nPos> sern movidos hacia abajo una  posicin en el array.
En otras palabras&comma. si se borra un item de la quinta posicin de un  array de diez elementos&comma. el elemento que estaba en la sexta posicin  ahora ser reubicado a la quinta posicin.  La longitud del array <aDestino>
permanece sin cambios y el ltimo  elemento en el array toma el valor NIL.
.br
.br
:hp2.Examples:ehp2.
.br
:p.
:lm margin=6.
.br
      *  El siguiente ejemplo crea un array lineal&comma. del cual se borra el
.br
         elemento en la quinta posicin.
.br

.br
         LOCAL aArray&colon.&eq. &lbrc. 1&comma. 2&comma. 3&comma. 4&comma. 5&comma. 6&comma. 7&comma. 8&comma. 9&comma. 10 &rbrc.
.br
         ADEL&lpar. aArray&comma. 5&rpar.
.br

.br
         Resultado&colon. aArray es &lbrc. 1&comma. 2&comma. 3&comma. 4&comma. 6&comma. 7&comma. 8&comma. 9&comma. NIL &rbrc.
.br
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin es totalmente compatible con CA&minus.Clipper.
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.El cdigo fuente est en arrays.c  La librera asociada es vm
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=15.ACOPY():elink.
.br
:link reftype=hd res=10. AINS():elink.
.br
:link reftype=hd res=9. AFILL():elink.
.br
:h2 id=ARRAY res=4.AFILL()
:i2 refid=ARRAYX.AFILL()
:p.AFILL&lpar.&rpar.
.br
.br
:hp2.Rellena un array con un valor especificado:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.AFILL&lpar. <aDestino>&comma. <xValor>&comma. &lbrk.<nInicio>&rbrk..&comma. &lbrk.<nContador>&rbrk.. &rpar. &minus.&minus.> aDestino:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<aDestino> es el nombre del array a rellenar
.br
:p.<xValor> es la expresin con la que ser rellenado <aDestino>
.br
:p.<nInicio> es la posicin de comienzo&comma. subndice del array
.br
:p.<nContador> es el nmero de elementos que se van a rellenar
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.AFILL&lpar.&rpar. retorna una referencia al array destino&comma. <aDestino>
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin rellena cada elemento del array llamado <aDestino> con  el valor <xValor>. Si es especificado&comma. <nInicio> marca el elemento  de inicio para continuar rellenando por <nContador> posiciones.  Si no es
especificado&comma. el valor de  <nInicio> ser 1&comma. y el valor de  <nContador> ser el valor de LEN&lpar.<aDestino>&rpar.&semi. y todos las posiciones  del array <aDestino> sern llenadas con la expresin de <xValor>.
.br
:p.Advertencia !&colon.  Esta funcin slo trabaja en una sola dimensin de <aDestino>.  Si hay punteros de referencia a otros arrays dentro de un subndice  de <aDestino> estos valores se perdern&comma. porque esta funcin los
sobreescribe con los nuevos valores.
.br
.br
:hp2.Examples:ehp2.
.br
:p.
:lm margin=6.
.br
      *  El siguiente ejemplo crea un array con valores asignados&comma. luego
.br
         lo rellena con el valor cinco.
.br

.br
         LOCAL aTest &colon.&eq. &lbrc. NIL&comma. 0&comma. 1&comma. 2 &rbrc.
.br
         Afill&lpar. aTest&comma. 5&rpar.               &slash.&slash. Resultado aTest es &lbrc. 5&comma. 5&comma. 5&comma. 5 &rbrc.
.br
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin es totalmente compatible con CA&minus.Clipper.
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.El cdigo fuente est en arrays.c  La librera asociada es vm
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=2.AADD():elink.
.br
:link reftype=hd res=14. AEVAL():elink.
.br
:link reftype=hd res=16. DBSTRUCT():elink.
.br
:link reftype=hd res=17. DIRECTORY():elink.
.br
:h2 id=ARRAY res=18.ASCAN()
:i2 refid=ARRAYX.ASCAN()
:p.ASCAN&lpar.&rpar.
.br
.br
:hp2.Busca en un array por un valor o hasta que el block devuelva .T.:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.ASCAN&lpar. <aDestino>&comma. <xBuscar>&comma.:ehp2.
:p.:hp2.&lbrk.<nInicio>&rbrk..&comma. &lbrk.<nContador>&rbrk.. &rpar. &minus.&minus.> nParadoEn:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<aDestino> es el nombre del array a examinar
.br
:p.<xBuscar> es la expresin a encontrar en <aDestino>
.br
:p.<nInicio> es la posicin a la cual comenzar la bsqueda
.br
:p.<nContador> es el nmero de elementos a examinar
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.ASCAN&lpar.&rpar. retorna un valor numrico <nParadoEn>&comma. de la posicin donde  <xBuscar> fu encontrada.
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin examina el contenido de un array llamado <aDestino> en  busca del valor de <xBuscar>. El valor devuelto es la posicin en el  array <aDestino> en el cual <xBuscar> fue encontrada.  Si esta expresin no es encontrada
el valor retornado es cero.
.br
:p.Si es especificada&comma. la posicin de inicio al cual comenzar la bsqueda  puede ser establecida con el valor pasado en <nInicio>. Por defecto  es uno.
.br
:p.Si es especificado&comma. el nmero de elementos del array a examinar puede  ser establecido con el valor pasado en <nContador>. Por defecto es el  nmero total de elementos en el array <aDestino>.
.br
:p.Si <xBuscar> es un bloque de cdigo&comma. la operacin de la funcin es  ligeramente diferente. Cada referencia del subindice del array es  pasada al bloque de cdigo para ser evaluada. La rutina de bsqueda  continuar hasta
que el valor obtenido del bloque de cdigo sea  verdadero &lpar..T.&rpar.  hasta que el final del array haya sido alcanzado.
.br
.br
:hp2.Examples:ehp2.
.br
:p.
:lm margin=6.
.br
      *  El siguiente ejemplo utiliza una funcin de biblioteca para llenar
.br
         el array aDir con los nombres de archivos en el directorio actual.
.br
         Posteriormente&comma. busca si entre ellos esta presente el archivo
.br
         test.prg&comma. devuelve cero si no esta&comma.  mayor de cero si est.
.br

.br
         LOCAL aDir &colon.&eq. DIRECTORY&lpar. &cdq.*.*&cdq.&rpar.
.br
         ? ASCAN&lpar. aDir&comma.&comma.&comma.&lbrc.&splitvbar.x&comma.y&splitvbar. x&lbrk.1&rbrk.. &eq.&eq. &cdq.test.prg&cdq. &rbrc. &rpar.
.br
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin no es compatible con CA&minus.Clipper . La funcin ASCAN&lpar.&rpar. de  Clipper es afectada por la condicin  SET EXACT ON&slash.OFF
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.El cdigo fuente est en arrays.c  La librera asociada es vm
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=19.AEVAL():elink.
.br
:link reftype=hd res=20. EVAL():elink.
.br
:h2 id=ARRAY res=19.AEVAL()
:i2 refid=ARRAYX.AEVAL()
:p.AEVAL&lpar.&rpar.
.br
.br
:hp2.Ejecuta un bloque de cdigo por cada elemento en el array:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.AEVAL&lpar.<aArray>&comma. <bBlock>&comma. &lbrk.<nInicio>&rbrk..&comma. &lbrk.<nContador>&rbrk..&rpar. &minus.&minus.> aArray:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<aArray> es el array a ser evaluado.
.br
:p.<bBloque> es el bloque de cdigo a evaluar para cada elemento  procesado  <nInicio> es el elemento de inicio del array a evaluar.
.br
:p.<nContador> es el nmero de elementos a procesar desde <nInicio>  hasta el final del array <aArray>
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.AEVAL&lpar.&rpar. retorna una referencia a <aArray>
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin evala y procesa los elementos en <aArray>.  Un bloque de cdigo pasado como <bBloque> define la operacion a ser  ejecutada sobre cada elemento del array. Todos los elementos en  <aArray> sern evaluados a menos que
sea especificada la posicin de  comienzo en <nInicio> por <nContador> elementos.  Por defecto <nInicio> es uno.
.br
:p.Dos parmetros son pasados al bloque de cdigo <bBloque>. Los elementos  individuales en el array son el primer parmetro y su posicin en el  array es el segundo.
.br
:p.AEVAL&lpar.&rpar. no reemplaza al bucle FOR...NEXT para procesar arrays.  Si un array es una unidad autnoma&comma. AEVAL&lpar.&rpar. es apropiado. Si el array  va a ser alterado  si los elementos van a ser reevaluados&comma. un
bucle FOR...NEXT es ms apropiado.
.br
.br
:hp2.Examples:ehp2.
.br
:p.
:lm margin=6.
.br
.br

.br
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin es totalmente compatible con CA&minus.Clipper.
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.El cdigo fuente est en arrays.c  La librera asociada es vm
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=21.EVAL():elink.
.br
:link reftype=hd res=22.DBEVAL():elink.
.br
:h2 id=ARRAY res=15.ACOPY()
:i2 refid=ARRAYX.ACOPY()
:p.ACOPY&lpar.&rpar.
.br
.br
:hp2.Copia elementos de un array a otro:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.ACOPY&lpar. <aOrigen>&comma. <aDestino>&comma. &lbrk.<nInicio>&rbrk..&comma. &lbrk.<nContador>&rbrk..&comma.:ehp2.
:p.:hp2.&lbrk.<nPosDestino>&rbrk.. &rpar.&minus.&minus.> aDestino:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<aOrigen> es el array desde el que se copian los elementos.
.br
:p.<aDestino> es el array al que se copian los elementos.
.br
:p.<nInicio>  es la posicin desde donde se inicia la copia en <aOrigen>.  Por defecto es uno.  <nContador> es el nmero de elementos a copiar comenzando en la  posicin <nInicio>
.br
:p.<nPosDestino> es la posicin de inicio en el array <aDestino> hacia  donde se copian los elementos. Por defecto es uno.
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.ACOPY&lpar.&rpar. retorna una referencia al array <aDestino>
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.ACOPY&lpar.&rpar. copia elementos desde el array <aOrigen> hacia el array  <aDestino>. Esta funcin copia todo tipo de datos.
.br
:p.Si un elemento en el array <aOrigen> es un puntero de referencia a  otro array &lpar.submatriz&rpar.&comma. esa referencia ser copiada al array  <aDestino> pero no todas las dimensiones sern copiadas de un array  al otro. Esto
debe ser realizado via funcin ACLONE&lpar.&rpar..
.br
:p.Note  Si el array <aOrigen> es mayor que <aDestino>&comma. los elementos en el  array comienzan a ser copiados en <nPosDestino> y continuan copiandose  hasta que el final del array <aDestino> es alcanzado&comma. los elementos
que sobran en <aOrigen> se descartan.  La funcin ACOPY&lpar.&rpar. no agrega posiciones al array destino&comma. el tamao  del array <aDestino> permanece constante.
.br
.br
:hp2.Examples:ehp2.
.br
:p.
:lm margin=6.
.br
      * El ejemplo siguiente copia un array sobre otro.
.br

.br
      LOCAL nContador &colon.&eq. 2&comma. nInicio &colon.&eq. 1&comma. aUltimo&comma. aPrimero
.br
      aUltimo  &colon.&eq. &lbrc. &cdq.HARBOUR&cdq.&comma. &cdq. es el &cdq.&comma. &cdq.Heredero&cdq. &rbrc.
.br
      aPrimero &colon.&eq. &lbrc. &cdq.CLIPPER&cdq.&comma. &cdq. fue el &cdq.&comma. &cdq.Pionero&cdq. &rbrc.
.br
      ACOPY&lpar. aUltimo&comma. aPrimero&comma. nInicio&comma. nContador&rpar.
.br
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin es totalmente compatible con CA&minus.Clipper.
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.El cdigo fuente est en arrays.c  La librera asociada es vm
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=23.ACLONE():elink.
.br
:link reftype=hd res=3.ADEL():elink.
.br
:link reftype=hd res=19.AEVAL():elink.
.br
:link reftype=hd res=4.AFILL():elink.
.br
:link reftype=hd res=5.AINS():elink.
.br
:link reftype=hd res=24.ASORT():elink.
.br
:h2 id=ARRAY res=23.ACLONE()
:i2 refid=ARRAYX.ACLONE()
:p.ACLONE&lpar.&rpar.
.br
.br
:hp2.Duplica un array anidado  multidimensional:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.ACLONE&lpar. <aOrigen> &rpar. &minus.&minus.> aDuplicado:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<aOrigen> es el nombre del array a ser clonado.
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.ACLONE&lpar.&rpar. retorna <aDuplicate> un nueva referencia a otro array  exactamente igual al original.
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin realiza una copia completa del array llamado <aOrigen>.  Crea todas las dimensiones en el array <aDestino> que existen en el  array original y luego llena cada dimensin con los mismos valores  de los elementos en el
original.  Ambos arrays coexisten como entidades distintas.
.br
.br
:hp2.Examples:ehp2.
.br
:p.
:lm margin=6.
.br
      * El ejemplo siguiente crea un array bidimensional y lo duplica.
.br
        Se muestra que son copiadas ambas dimensiones.
.br

.br
        LOCAL aOrigen&comma. aDestino
.br
        aOrigen  &colon.&eq. &lbrc. &lbrc.1&comma. 2&rbrc.&comma. &lbrc.3&comma. 4&rbrc.&comma. &lbrc.5&comma. 6&rbrc.&comma. &lbrc.7&comma. 8&rbrc.&comma. &lbrc.9&comma. 10&rbrc. &rbrc.
.br
        aDestino &colon.&eq. ACLONE&lpar. aOrigen &rpar.
.br

.br
        * primera dimensin
.br
        ? &cdq.Impares son&colon. &cdq.                &slash.&slash. Resultado&colon. es &lbrc.1&comma. 3&comma. 5&comma. 7&comma. 9&rbrc.
.br
        FOR n &colon.&eq. 1 TO LEN&lpar. aDestino&rpar.
.br
            ?? aDestino &lbrk.n&rbrk..&lbrk.1&rbrk..
.br
        NEXT
.br

.br
        * segunda dimensin
.br
        ? &cdq.Pares   son&colon. &cdq.                &slash.&slash. Resultado&colon. es &lbrc.2&comma. 4&comma. 6&comma. 8&comma. 10&rbrc.
.br
        FOR n &colon.&eq. 1 TO LEN&lpar. aDestino&rpar.
.br
            ?? aDestino &lbrk.n&rbrk..&lbrk.2&rbrk..
.br
        NEXT
.br

.br
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.Clipper retorna NIL si el parmetro no es un array.
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.El cdigo fuente est en arrays.c  La librera asociada es vm
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=15.ACOPY():elink.
.br
:link reftype=hd res=3.ADEL():elink.
.br
:link reftype=hd res=5.AINS():elink.
.br
:link reftype=hd res=7.ASIZE():elink.
.br
:h2 id=ARRAY res=24.ASORT()
:i2 refid=ARRAYX.ASORT()
:p.ASORT&lpar.&rpar.
.br
.br
:hp2.Ordena un array:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.ASORT&lpar. <aDestino>&comma. &lbrk.<nInicio>&rbrk..&comma. &lbrk.<nContador>&rbrk..&comma.:ehp2.
:p.:hp2.&lbrk.<bOrden>&rbrk.. &rpar. &minus.&minus.> aDestino:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<aDestino> es el nombre del array a ser ordenado.
.br
:p.<nInicio> es el primer elemento para comenzar el ordenamiento.  Por defecto es uno.
.br
:p.<nContador> es el nmero de elementos a ordenar comenzando en la  posicin <nInicio>. Por defecto son todos los elementos.
.br
:p.<bOrden> es el bloque de cdigo para el orden de ordenamiento&comma. por  defecto es en orden ascendente &lbrc.&splitvbar. x&comma. y &splitvbar. x < y &rbrc..  El bloque de cdigo debe recibir dos elementos del array como
parametros y debe retornar .T. si el orden es el correcto&comma.  .F. en caso contrario.
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.ASORT&lpar.&rpar. retorna una referencia al reciente array ordenado <aDestino>   NIL si el parmetro <aDestino> no es un array.
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcion ordena todo  parte de un array dado. Si <bOrden> es  omitido&comma. la funcin espera que <aDestino> sea un array unidimensional  conteniendo un solo tipo de datos &lpar.uno de&colon. Character&comma. Date&comma.
Logical&comma.  Numeric&rpar. y ordena este array en orden ascendente&colon. los caracteres son  ordenados por su valor ASCII&comma. las fechas son ordenadas cronologicamente  el valor lgico .F. va antes de .T. y los valores
numricos son  ordenados por su valor.
.br
:p.Si <bOrden> es especificado este es usado para manejar la forma de  ordenamiento. Cada vez que el bloque es evaluado&comma. dos elementos del  array son pasados al bloque de cdigo&comma. y el bloque debe retornar un  valor
lgico que define si esos elementos estan en orden &lpar..T.&rpar.  no  &lpar..F.&rpar.. Usando este bloque se puede ordenar arrays multidimensionales  hacer un ordenamiento descendente  an &lpar.pero para que querria Ud.
hacerlo&rpar. ordenar un array que contenga diferentes tipo de datos.
.br
.br
:hp2.Examples:ehp2.
.br
:p.
:lm margin=6.
.br
      * El siguiente ejemplo ordena valores numericos en orden ascendente
.br

.br
        ASORT&lpar. &lbrc. 3&comma. 1&comma. 4&comma. 42&comma. 5&comma. 9 &rbrc. &rpar.   &slash.&slash. Resultado&colon. &lbrc. 1&comma. 3&comma. 4&comma. 5&comma. 9&comma. 42 &rbrc.
.br

.br
      * El siguiente ejemplo ordena cadenas en orden descendente
.br
        LOCAL aKeys &colon.&eq. &lbrc. &cdq.Ctrl&cdq.&comma. &cdq.Alt&cdq.&comma. &cdq.Delete&cdq. &rbrc.&comma. n
.br
        LOCAL bOrden &colon.&eq. &lbrc.&splitvbar. x&comma. y &splitvbar. UPPER&lpar. x &rpar. > UPPER&lpar. y &rpar. &rbrc.
.br
        ASORT&lpar. aKeys&comma.&comma.&comma. bOrden &rpar.
.br
        FOR n &eq. 1 TO LEN&lpar. aKeys &rpar.
.br
            ? aKeys &lbrk.n&rbrk..          &slash.&slash. Resultado&colon. &lbrc. &cdq.Delete&cdq.&comma. &cdq.Ctrl&cdq.&comma. &cdq.Alt&cdq.&rbrc.
.br
        NEXT
.br

.br
      * El siguiente ejemplo ordena dos arrays bidimensionales de acuerdo
.br
        al segundo elemento de cada par.
.br

.br
        LOCAL aPair &colon.&eq. &lbrc. &lbrc.&cdq.Sun&cdq.&comma.8&rbrc.&comma. &lbrc.&cdq.Mon&cdq.&comma.1&rbrc.&comma. &lbrc.&cdq.Tue&cdq.&comma.57&rbrc.&comma. &lbrc.&cdq.Wed&cdq.&comma.&minus.6&rbrc. &rbrc.
.br
        ASORT&lpar. aPair&comma.&comma.&comma. &lbrc.&splitvbar. x&comma. y &splitvbar. x&lbrk.2&rbrk.. < y&lbrk.2&rbrk.. &rbrc. &rpar.
.br

.br
        FOR n &eq. 1 TO LEN&lpar. aPair &rpar.
.br
            ? aPair &lbrk.n&rbrk..&lbrk.1&rbrk..&comma.  aPair &lbrk.n&rbrk..&lbrk.2&rbrk..
.br
        NEXT
.br
        &slash.&slash. Resultado&colon. &lbrc. &lbrc.&cdq.Wed&cdq.&comma.&minus.6&rbrc.&comma. &lbrc.&cdq.Mon&cdq.&comma.1&rbrc.&comma. &lbrc.&cdq.Sun&cdq.&comma.8&rbrc.&comma. &lbrc.&cdq.Tue&cdq.&comma.57&rbrc. &rbrc.
.br
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.La frecuencia de llamada al bloque de cdigo y el orden difiere de  Clipper debido a que Harbour usa un algoritmo distinto &lpar.ms rpido&rpar.  de ordenamiento &lpar.quicksort&rpar..
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.El cdigo fuente est en arrays.c  La librera asociada es vm
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=18.ASCAN():elink.
.br
:link reftype=hd res=21.EVAL():elink.
.br
:link reftype=hd res=25.SORT:elink.
.br
:h1 CONVY.CONVERSIN BINARIA
:h2  res=26.BIN2W()
:i1 id=CONVEX.CONVERSIN BINARIA
:i2 refid=CONVEX.BIN2W()
:p.BIN2W&lpar.&rpar.
.br
.br
:hp2.Convierte 2 bytes de un entero corto sin signo en un nmero en Harbour:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.BIN2W&lpar. <cBuffer> &rpar. &minus.&minus.> nNumero:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<cBuffer> es una cadena de caracteres que contiene un entero corto  sin signo codificado en 16 bits &lpar.byte menos significativo primero&rpar..  Los primeros dos bytes son tenidos en cuenta&comma. si hay ms son  ignorados.
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.BIN2W&lpar.&rpar. retorna un nmero entero &lpar. cero si <cBuffer> no es una cadena&rpar..
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.BIN2W&lpar.&rpar. es una de las funciones de conversin binaria&comma. de bajo nivel.  Estas funciones convierten entre un valor numrico en Harbour y una  representacin de cadena de un valor numrico dado.  BIN2W&lpar.&rpar.
toma dos bytes de un entero corto sin signo codificado en 16  bits y los convierte en un valor numrico estandar de Harbour.
.br
:p.Ud podra preguntarse cual es la necesidad de este tipo de funciones&comma.  bueno&comma. primero de todo esta permite leer&slash.escribir informacin desde&slash.  hacia un archivo binario &lpar.como extraer informacin de la
cabecera de  un archivo DBF&rpar.&comma. es tambin una forma til de compartir informacin  desde otra fuente distinta a Harbour &lpar.lenguaje C por ejemplo&rpar..  BIN2W&lpar.&rpar. es la inversa de W2BIN&lpar.&rpar.
.br
.br
:hp2.Examples:ehp2.
.br
:p.
:lm margin=6.
.br
      &slash.&slash. Muestra la longitud de la cabecera de un DBF
.br
      FUNCTION main&lpar.&rpar.
.br
      LOCAL nHandle&comma. cBuffer &colon.&eq. SPACE&lpar. 2 &rpar.
.br
      nHandle &colon.&eq. FOPEN&lpar. &cdq.test.dbf&cdq. &rpar.
.br

.br
      IF nHandle > 0
.br
         FSEEK&lpar. nHandle&comma. 8 &rpar.
.br
         FREAD&lpar. nHandle&comma. @cBuffer&comma. 2 &rpar.
.br
         ? &cdq.Longitud de la cabecera del DBF en bytes&colon.&cdq.&comma. BIN2W&lpar. cBuffer &rpar.
.br
         FCLOSE&lpar. nHandle &rpar.
.br
      ELSE
.br
         ? &cdq.No puedo abrir el archivo...&cdq.
.br
      ENDIF
.br
      RETURN NIL
.br
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.BIN2W&lpar.&rpar. funciona exactamente como la funcin de CA&minus.Clipper&comma. BIN2W&lpar.&rpar.
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.La librera es rtl
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=27.BIN2I():elink.
.br
:link reftype=hd res=28.BIN2L():elink.
.br
:link reftype=hd res=29.BIN2U():elink.
.br
:link reftype=hd res=30.I2BIN():elink.
.br
:link reftype=hd res=31.L2BIN():elink.
.br
:link reftype=hd res=32.W2BIN():elink.
.br
:link reftype=hd res=33.WORD():elink.
.br
:link reftype=hd res=34.U2BIN():elink.
.br
:link reftype=hd res=35.FREAD():elink.
.br
:h2 id=CONVY res=27.BIN2I()
:i2 refid=CONVEX.BIN2I()
:p.BIN2I&lpar.&rpar.
.br
.br
:hp2.Convierte 2 bytes de un entero corto con signo en un nmero en Harbour:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.BIN2I&lpar. <cBuffer> &rpar. &minus.&minus.> nNumero:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<cBuffer> es una cadena de caracteres que contiene un entero corto  con signo codificado en 16 bits &lpar.byte menos significativo primero&rpar..  Los primeros dos bytes son tenidos en cuenta&comma. si hay ms son  ignorados.
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.BIN2I&lpar.&rpar. retorna un nmero entero &lpar. cero si <cBuffer> no es una cadena&rpar..
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.BIN2I&lpar.&rpar. es una de las funciones de conversin binaria&comma. de bajo nivel.  Estas funciones convierten entre un valor numrico en Harbour y una  representacin de cadena de un valor numrico dado.  BIN2I&lpar.&rpar.
toma dos bytes de un entero corto con signo codificado en 16  bits y los convierte en un valor numrico estndar de Harbour.
.br
:p.Ud podra preguntarse cual es la necesidad de este tipo de funciones&comma.  bueno&comma. primero de todo esta permite leer&slash.escribir informacin desde&slash.  hacia un archivo binario &lpar.como extraer informacin de la
cabecera de  un archivo DBF&rpar.&comma. es tambien una forma til de compartir informacin  desde otra fuente distinta a Harbour &lpar.lenguaje C por ejemplo&rpar..  BIN2I&lpar.&rpar. es la inversa de I2BIN&lpar.&rpar.
.br
.br
:hp2.Examples:ehp2.
.br
:p.
:lm margin=6.
.br
      &slash.&slash. Muestra la fecha de la ltima actualizacin del DBF
.br
      FUNCTION main&lpar.&rpar.
.br
      LOCAL nHandle&comma. cAno&comma. cMes&comma. cDia
.br
      nHandle &colon.&eq. FOPEN&lpar. &cdq.test.dbf&cdq. &rpar.
.br

.br
      IF nHandle > 0
.br
         FSEEK&lpar. nHandle&comma. 1 &rpar.
.br
         cAno &colon.&eq. cMes &colon.&eq. cDia &colon.&eq. &cdq. &cdq.
.br
         FREAD&lpar. nHandle&comma. @cAno&comma. 1 &rpar.
.br
         FREAD&lpar. nHandle&comma. @cMes&comma. 1 &rpar.
.br
         FREAD&lpar. nHandle&comma. @cDia&comma. 1 &rpar.
.br
         ? &cdq.Fecha de actualizacin&colon.&cdq.&comma. BIN2I&lpar. cAno &rpar.&comma. BIN2I&lpar. cMes &rpar.&comma. &semi.
.br
                                      BIN2I&lpar. cDia &rpar.
.br
         FCLOSE&lpar. nHandle &rpar.
.br
      ELSE
.br
         ? &cdq.No puedo abrir el archivo...&cdq.
.br
      ENDIF
.br
      RETURN NIL
.br
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.BIN2I&lpar.&rpar. funciona exactamente como la funcin de CA&minus.Clipper&comma. BIN2I&lpar.&rpar.
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.La librera es rtl
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=28.BIN2L():elink.
.br
:link reftype=hd res=29.BIN2U():elink.
.br
:link reftype=hd res=26.BIN2W():elink.
.br
:link reftype=hd res=30.I2BIN():elink.
.br
:link reftype=hd res=31.L2BIN():elink.
.br
:link reftype=hd res=32.W2BIN():elink.
.br
:link reftype=hd res=33.WORD():elink.
.br
:link reftype=hd res=34.U2BIN():elink.
.br
:link reftype=hd res=35.FREAD():elink.
.br
:h2 id=CONVY res=28.BIN2L()
:i2 refid=CONVEX.BIN2L()
:p.BIN2L&lpar.&rpar.
.br
.br
:hp2.Convierte 4 bytes de un entero largo con signo en un nmero en Harbour:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.BIN2L&lpar. <cBuffer> &rpar. &minus.&minus.> nNumero:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<cBuffer> es una cadena de caracteres que contiene un entero largo  con signo codificado en 32 bits &lpar.byte menos significativo primero&rpar..  Los primeros cuatro bytes son tenidos en cuenta&comma. si hay ms son  ignorados.
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.BIN2L&lpar.&rpar. retorna un nmero entero &lpar. cero si <cBuffer> no es una cadena&rpar..
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.BIN2L&lpar.&rpar. es una de las funciones de conversin binaria&comma. de bajo nivel.  Estas funciones convierten entre un valor numrico en Harbour y una  representacin de cadena de un valor numrico dado.  BIN2L&lpar.&rpar.
toma cuatro bytes de un entero largo con signo codificado en  32 bits y los convierte en un valor numrico estndar de Harbour.
.br
:p.Ud podra preguntarse cual es la necesidad de este tipo de funciones&comma.  bueno&comma. primero de todo esta permite leer&slash.escribir informacin desde&slash.  hacia un archivo binario &lpar.como extraer informacin de la
cabecera de  un archivo DBF&rpar.&comma. es tambien una forma til de compartir informacin  desde otra fuente distinta a Harbour &lpar.lenguaje C por ejemplo&rpar..  BIN2L&lpar.&rpar. es la inversa de L2BIN&lpar.&rpar.
.br
.br
:hp2.Examples:ehp2.
.br
:p.
:lm margin=6.
.br
      &slash.&slash. Muestra el nmero de registros en el DBF
.br
      FUNCTION main&lpar.&rpar.
.br
      LOCAL nHandle&comma. cBuffer &colon.&eq. SPACE&lpar. 4 &rpar.
.br
      nHandle &colon.&eq. FOPEN&lpar. &cdq.test.dbf&cdq. &rpar.
.br

.br
      IF nHandle > 0
.br
         FSEEK&lpar. nHandle&comma. 4 &rpar.
.br
         FREAD&lpar. nHandle&comma. @cBuffer&comma. 4 &rpar.
.br
         ? &cdq.nmero de registros en el archivo&colon.&cdq.&comma. BIN2L&lpar. cBuffer &rpar.
.br
         FCLOSE&lpar. nHandle &rpar.
.br
      ELSE
.br
         ? &cdq.No puedo abrir el archivo...&cdq.
.br
      ENDIF
.br
      RETURN NIL
.br
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.BIN2L&lpar.&rpar. funciona exactamente como la funcin de CA&minus.Clipper&comma. BIN2L&lpar.&rpar.
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.La librera es rtl
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=27.BIN2I():elink.
.br
:link reftype=hd res=29.BIN2U():elink.
.br
:link reftype=hd res=26.BIN2W():elink.
.br
:link reftype=hd res=30.I2BIN():elink.
.br
:link reftype=hd res=31.L2BIN():elink.
.br
:link reftype=hd res=32.W2BIN():elink.
.br
:link reftype=hd res=33.WORD():elink.
.br
:link reftype=hd res=34.U2BIN():elink.
.br
:link reftype=hd res=35.FREAD():elink.
.br
:h2 id=CONVY res=29.BIN2U()
:i2 refid=CONVEX.BIN2U()
:p.BIN2U&lpar.&rpar.
.br
.br
:hp2.Convierte 4 bytes de un entero largo sin signo en un nmero en Harbour:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.BIN2U&lpar. <cBuffer> &rpar. &minus.&minus.> nNumero:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<cBuffer> es una cadena de caracteres que contiene un entero largo  sin signo codificado en 32 bits &lpar.byte menos significativo primero&rpar..  Los primeros cuatro bytes son tenidos en cuenta&comma. si hay ms son  ignorados.
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.BIN2U&lpar.&rpar. retorna un nmero entero &lpar. cero si <cBuffer> no es una cadena&rpar..
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.BIN2U&lpar.&rpar. es una de las funciones de conversin binaria&comma. de bajo nivel.  Estas funciones convierten entre un valor numrico en Harbour y una  representacin de cadena de un valor numrico dado.  BIN2U&lpar.&rpar.
toma cuatro bytes de un entero largo sin signo codificado en  32 bits y los convierte en un valor numrico estndar de Harbour.
.br
:p.Ud podra preguntarse cual es la necesidad de este tipo de funciones&comma.  bueno&comma. primero de todo esta permite leer&slash.escribir informacin desde&slash.  hacia un archivo binario &lpar.como extraer informacin de la
cabecera de  un archivo DBF&rpar.&comma. es tambien una forma util de compartir informacin  desde otra fuente distinta a Harbour &lpar.lenguaje C por ejemplo&rpar..  BIN2U&lpar.&rpar. es la inversa de U2BIN&lpar.&rpar.
.br
.br
:hp2.Examples:ehp2.
.br
:p.
:lm margin=6.
.br
      &slash.&slash. Muestra el nmero de registros en el DBF
.br
      FUNCTION main&lpar.&rpar.
.br
      LOCAL nHandle&comma. cBuffer &colon.&eq. SPACE&lpar. 4 &rpar.
.br
      nHandle &colon.&eq. FOPEN&lpar. &cdq.test.dbf&cdq. &rpar.
.br

.br
      IF nHandle > 0
.br
         FSEEK&lpar. nHandle&comma. 4 &rpar.
.br
         FREAD&lpar. nHandle&comma. @cBuffer&comma. 4 &rpar.
.br
         ? &cdq.Nmero de registros en el archivo&colon.&cdq.&comma. BIN2U&lpar. cBuffer &rpar.
.br
         FCLOSE&lpar. nHandle &rpar.
.br
      ELSE
.br
         ? &cdq.No puedo abrir el archivo...&cdq.
.br
      ENDIF
.br
      RETURN NIL
.br
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.BIN2U&lpar.&rpar. es una funcin de compatibilidad con XBase++ y no existe como  una funcin estndar en CA&minus.Clipper 5.x  Esta funcin es solamente visible si el archivo source&slash.rtl&slash.binnum.c  fue compilado con la
bandera HB&us.COMPAT&us.XPP.
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.La librera es rtl
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=27.BIN2I():elink.
.br
:link reftype=hd res=28.BIN2L():elink.
.br
:link reftype=hd res=26.BIN2W():elink.
.br
:link reftype=hd res=30.I2BIN():elink.
.br
:link reftype=hd res=31.L2BIN():elink.
.br
:link reftype=hd res=32.W2BIN():elink.
.br
:link reftype=hd res=33.WORD():elink.
.br
:link reftype=hd res=34.U2BIN():elink.
.br
:link reftype=hd res=35.FREAD():elink.
.br
:h2 id=CONVY res=30.I2BIN()
:i2 refid=CONVEX.I2BIN()
:p.I2BIN&lpar.&rpar.
.br
.br
:hp2.Convierte un nmero en Harbour en 2 bytes de un entero corto con signo en:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.I2BIN&lpar. <nNumero> &rpar. &minus.&minus.> cBuffer:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<nNumero> es un valor numrico a convertir &lpar.los digitos decimales  son ignorados&rpar..
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.I2BIN&lpar.&rpar. retorna una cadena de caracteres de dos bytes que  contienen un entero corto con signo&comma. codificado en 16 bits &lpar.byte  menos significativo primero&rpar..
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.I2BIN&lpar.&rpar. es una de las funciones de conversin binaria&comma. de bajo nivel.  Estas funciones convierten entre un valor numrico en Harbour y una  representacin de cadena de un valor numrico dado.  I2BIN&lpar.&rpar.
toma un valor numrico y lo convierte en dos bytes de  un entero corto con signo&comma. codificado en 16 bits.
.br
:p.Ud podra preguntarse cual es la necesidad de este tipo de funciones&comma.  bueno&comma. primero de todo esta permite leer&slash.escribir informacin desde&slash.  hacia un archivo binario &lpar.como extraer informacin de la
cabecera de  un archivo DBF&rpar.&comma. es tambien una forma util de compartir informacin  desde otra fuente distinta a Harbour &lpar.lenguaje C por ejemplo&rpar..  I2BIN&lpar.&rpar. es la inversa de BIN2I&lpar.&rpar.
.br
.br
:hp2.Examples:ehp2.
.br
:p.
:lm margin=6.
.br
      &slash.&slash. El ejemplo cambia la &cdq.fecha de ultima actualizacin&cdq. del DBF
.br
      #include &cdq.fileio.ch&cdq.
.br
      FUNCTION main&lpar.&rpar.
.br
      LOCAL nHandle&comma. cAno&comma. cMes&comma. cDia
.br

.br
      USE test
.br
      ? &cdq.La fecha original de actualizacin es&colon.&cdq.&comma. LUPDATE&lpar.&rpar.
.br
      CLOSE
.br
      nHandle &colon.&eq. FOPEN&lpar. &cdq.test.dbf&cdq.&comma. FO&us.READWRITE &rpar.
.br

.br
      IF nHandle > 0
.br
         FSEEK&lpar. nHandle&comma. 1&comma. &rpar.
.br
         cAno &colon.&eq. I2BIN&lpar. 68 &rpar.
.br
         cMes &colon.&eq. I2BIN&lpar.  8 &rpar.
.br
         cDia &colon.&eq. I2BIN&lpar.  1 &rpar.
.br
         FWRITE&lpar. nHandle&comma. cAno &comma. 1 &rpar.   &slash.&slash. escribe solo el primer byte
.br
         FWRITE&lpar. nHandle&comma. cMes&comma. 1 &rpar.
.br
         FWRITE&lpar. nHandle&comma. cDia&comma. 1 &rpar.
.br
         FCLOSE&lpar. nHandle &rpar.
.br
         USE test
.br
         ? &cdq.La nueva fecha de actualizacin es&colon.&cdq.&comma. LUPDATE&lpar.&rpar.
.br
         CLOSE
.br
      ELSE
.br
         ? &cdq.No puedo abrir el archivo...&cdq.
.br
      ENDIF
.br
      RETURN NIL
.br
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.I2BIN&lpar.&rpar. funciona exactamente como la funcin de CA&minus.Clipper&comma. I2BIN&lpar.&rpar.
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.La librera es rtl
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=27.BIN2I():elink.
.br
:link reftype=hd res=28.BIN2L():elink.
.br
:link reftype=hd res=29.BIN2U():elink.
.br
:link reftype=hd res=26.BIN2W():elink.
.br
:link reftype=hd res=31.L2BIN():elink.
.br
:link reftype=hd res=32.W2BIN():elink.
.br
:link reftype=hd res=33.WORD():elink.
.br
:link reftype=hd res=34.U2BIN():elink.
.br
:link reftype=hd res=36.FWRITE():elink.
.br
:h2 id=CONVY res=32.W2BIN()
:i2 refid=CONVEX.W2BIN()
:p.W2BIN&lpar.&rpar.
.br
.br
:hp2.Convierte un nmero en Harbour en 2 bytes de un entero corto sin signo en:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.W2BIN&lpar. <nNumero> &rpar. &minus.&minus.> cBuffer:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<nNumero> es un valor numrico a convertir &lpar.los digitos decimales  son ignorados&rpar..
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.W2BIN&lpar.&rpar. retorna una cadena de caracteres de dos bytes que  contienen un entero corto sin signo&comma. codificado en 16 bits &lpar.byte  menos significativo primero&rpar..
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.W2BIN&lpar.&rpar. es una de las funciones de conversin binaria&comma. de bajo nivel.  Estas funciones convierten entre un valor numrico en Harbour y una  representacin de cadena de un valor numrico dado.  W2BIN&lpar.&rpar.
toma un valor numrico y lo convierte en dos bytes de  un entero corto sin signo&comma. codificado en 16 bits.
.br
:p.Ud podra preguntarse cual es la necesidad de este tipo de funciones&comma.  bueno&comma. primero de todo esta permite leer&slash.escribir informacin desde&slash.  hacia un archivo binario &lpar.como extraer informacin de la
cabecera de  un archivo DBF&rpar.&comma. es tambien una forma util de compartir informacin  desde otra fuente distinta a Harbour &lpar.lenguaje C por ejemplo&rpar..  W2BIN&lpar.&rpar. es la inversa de BIN2W&lpar.&rpar.
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.W2BIN&lpar.&rpar. es una funcin de compatibilidad con XBase++ y no existe como  una funcin estandar en CA&minus.Clipper 5.x  Esta funcin es solamente visible si el archivo source&slash.rtl&slash.binnum.c  fue compilado con la
bandera HB&us.COMPAT&us.XPP.
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.La librera es rtl
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=27.BIN2I():elink.
.br
:link reftype=hd res=28.BIN2L():elink.
.br
:link reftype=hd res=29.BIN2U():elink.
.br
:link reftype=hd res=26.BIN2W():elink.
.br
:link reftype=hd res=30.I2BIN():elink.
.br
:link reftype=hd res=31.L2BIN():elink.
.br
:link reftype=hd res=33.WORD():elink.
.br
:link reftype=hd res=34.U2BIN():elink.
.br
:link reftype=hd res=36.FWRITE():elink.
.br
:h2 id=CONVY res=31.L2BIN()
:i2 refid=CONVEX.L2BIN()
:p.L2BIN&lpar.&rpar.
.br
.br
:hp2.Convierte un nmero en Harbour en 4 bytes de un entero largo con signo en:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.L2BIN&lpar. <nNumero> &rpar. &minus.&minus.> cBuffer:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<nNumero> es un valor numrico a convertir &lpar.los digitos decimales  son ignorados&rpar..
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.L2BIN&lpar.&rpar. retorna una cadena de caracteres de cuatro bytes que  contienen un entero largo con signo&comma. codificado en 32 bits &lpar.byte  menos significativo primero&rpar..
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.L2BIN&lpar.&rpar. es una de las funciones de conversin binaria&comma. de bajo nivel.  Estas funciones convierten entre un valor numrico en Harbour y una  representacin de cadena de un valor numrico dado.  L2BIN&lpar.&rpar.
toma un valor numrico y lo convierte en cuatro bytes de  un entero largo con signo&comma. codificado en 32 bits.
.br
:p.Ud podra preguntarse cual es la necesidad de este tipo de funciones&comma.  bueno&comma. primero de todo esta permite leer&slash.escribir informacin desde&slash.  hacia un archivo binario &lpar.como extraer informacin de la
cabecera de  un archivo DBF&rpar.&comma. es tambien una forma til de compartir informacin  desde otra fuente distinta a Harbour &lpar.lenguaje C por ejemplo&rpar..  L2BIN&lpar.&rpar. es la inversa de BIN2L&lpar.&rpar.
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.L2BIN&lpar.&rpar. funciona exactamente como la funcin de CA&minus.Clipper&comma. L2BIN&lpar.&rpar.
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.La librera es rtl
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=27.BIN2I():elink.
.br
:link reftype=hd res=28.BIN2L():elink.
.br
:link reftype=hd res=29.BIN2U():elink.
.br
:link reftype=hd res=26.BIN2W():elink.
.br
:link reftype=hd res=30.I2BIN():elink.
.br
:link reftype=hd res=32.W2BIN():elink.
.br
:link reftype=hd res=33.WORD():elink.
.br
:link reftype=hd res=34.U2BIN():elink.
.br
:link reftype=hd res=36.FWRITE():elink.
.br
:h2 id=CONVY res=34.U2BIN()
:i2 refid=CONVEX.U2BIN()
:p.U2BIN&lpar.&rpar.
.br
.br
:hp2.Convierte un nmero en Harbour en 4 bytes de un entero largo sin signo en:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.U2BIN&lpar. <nNumero> &rpar. &minus.&minus.> cBuffer:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<nNumero> es un valor numrico a convertir &lpar.los digitos decimales  son ignorados&rpar..
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.U2BIN&lpar.&rpar. retorna una cadena de caracteres de cuatro bytes que  contienen un entero largo sin signo&comma. codificado en 32 bits &lpar.byte  menos significativo primero&rpar..
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.U2BIN&lpar.&rpar. es una de las funciones de conversin binaria&comma. de bajo nivel.  Estas funciones convierten entre un valor numrico en Harbour y una  representacin de cadena de un valor numrico dado.  U2BIN&lpar.&rpar.
toma un valor numrico y lo convierte en cuatro bytes de  un entero largo sin signo&comma. codificado en 32 bits.
.br
:p.Ud podra preguntarse cual es la necesidad de este tipo de funciones&comma.  bueno&comma. primero de todo esta permite leer&slash.escribir informacin desde&slash.  hacia un archivo binario &lpar.como extraer informacin de la
cabecera de  un archivo DBF&rpar.&comma. es tambien una forma til de compartir informacin  desde otra fuente distinta a Harbour &lpar.lenguaje C por ejemplo&rpar..  U2BIN&lpar.&rpar. es la inversa de BIN2U&lpar.&rpar.
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.U2BIN&lpar.&rpar. es una funcin de compatibilidad con XBase++ y no existe como  una funcin estndar en CA&minus.Clipper 5.x  Esta funcin es solamente visible si el archivo source&slash.rtl&slash.binnum.c  fue compilado con la
bandera HB&us.COMPAT&us.XPP.
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.La librera es rtl
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=27.BIN2I():elink.
.br
:link reftype=hd res=28.BIN2L():elink.
.br
:link reftype=hd res=29.BIN2U():elink.
.br
:link reftype=hd res=26.BIN2W():elink.
.br
:link reftype=hd res=30.I2BIN():elink.
.br
:link reftype=hd res=31.L2BIN():elink.
.br
:link reftype=hd res=32.W2BIN():elink.
.br
:link reftype=hd res=33.WORD():elink.
.br
:link reftype=hd res=36.FWRITE():elink.
.br
:h2 id=CONVY res=33.WORD()
:i2 refid=CONVEX.WORD()
:p.WORD&lpar.&rpar.
.br
.br
:hp2.Convierte parmetros de doble precisin del mandato CALL a enteros.:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.WORD&lpar. <nDoble> &rpar. &minus.&minus.> <nEntero>:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<nDoble> es un valor numrico de doble precisin.
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.WORD&lpar.&rpar. retorna un entero en el rango&colon. &minus.32767 a +32767
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin convierte valores de doble precisin a enteros&comma. para  ser usados con el mandato CALL.
.br
.br
:hp2.Examples:ehp2.
.br
:p.
:lm margin=6.
.br
      &slash.&slash. Utiliza WORD&lpar.&rpar. como argumento del mandato CALL
.br
      CALL INVENT WITH WORD&lpar.75300&rpar.
.br

.br
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.La NG de Clipper NG establece que WORD&lpar.&rpar. funcionar solamente cuando  sea usada en la lista de parmetros del comando CALL&comma. de otra manera  devolver NIL&comma. en Harbour esta funcionar donde sea.
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.La librera es rtl
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=37.CALL:elink.
.br
:h1 ENTRY.ENTRADA Y SALIDA DE DATOS
:h2  res=38.DBEDIT()*
:i1 id=ENTRAX.ENTRADA Y SALIDA DE DATOS
:i2 refid=ENTRAX.DBEDIT()*
:p.DBEDIT&lpar.&rpar.*
.br
.br
:hp2.Despliega registros en una tabla:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.DBEDIT&lpar. &lbrk.<nSup>&rbrk..&comma. &lbrk.<nIzq>&rbrk..&comma. &lbrk.<nInf>&rbrk..&comma. &lbrk.<nDer>&rbrk..&comma. &lbrk.<acColumnas>&rbrk..&comma. &semi.:ehp2.
:p.:hp2.&lbrk.<xFuncionUsuario>&rbrk..&comma. &lbrk.<xColumnSayPictures>&rbrk..&comma. &lbrk.<xCabeceraColumna>&rbrk..&comma. &semi.:ehp2.
:p.:hp2.&lbrk.<xSeparadorCabecera>&rbrk..&comma. &lbrk.<xSeparadorColumna>&rbrk..&comma. &semi.:ehp2.
:p.:hp2.&lbrk.<xSeparadorPie>&rbrk..&comma. &lbrk.<xPieColumna>&rbrk.. &rpar. &minus.&minus.> lExito:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<nSup> coordenada para la fila Superior de visualizacin. El rango  para <nSup> va de cero a MAXROW&lpar.&rpar.&comma. por defecto es cero.
.br
:p.<nIzq> coordenada para la columna izquierda de visualizacin. El rango  para <nIzq> va de cero a MAXCOL&lpar.&rpar.&comma. por defecto es cero.
.br
:p.<nInf> coordenada para la fila inferior de visualizacin. El rango  para <nInf> va de cero a MAXROW&lpar.&rpar.&comma. por defecto es MAXROW&lpar.&rpar..
.br
:p.<nDer> coordenada para la columna derecha de visualizacin. El rango  para <nDer> va de cero a MAXCOL&lpar.&rpar.&comma. por defecto es MAXCOL&lpar.&rpar..
.br
:p.<acColumnas> es un array de expresiones de caracteres que contienen  los nombres de los campos de la base de datos&comma.o expresiones para la  visualizacin en cada columna.  Si no es especificada&comma. por defecto es la
visualizacin de todos los  campos de la base de datos en el area de trabajo actual.
.br
:p.<xFuncionUsuario> es el nombre de una funcin  un bloque de codigo  que podra ser llamado cada vez que una tecla no reconocida ha sido  presionada  cuando no hay ms teclas para ser procesadas y DBEDIT&lpar.&rpar.  va al modo
inactivo. Si <xFuncionUsuario> es una cadena de caracteres&comma.  esta debe contener el nombre de una funcin de usuario definida&comma. que  sea vlida y sin parntesis.  Ambos la funcin definida por el usuario  el bloque de
cdigo debern  aceptar dos parmetros&colon. nModo y nActualColumna.  Ambos deberan devolver un valor numrico que corresponda a uno de  los cdigos de retorno esperados.  &lpar.Vea la tabla ms abajo con la lista de nModo y
los cdigos de retorno&rpar.
.br
:p.<xColumnSayPictures> es un molde &lpar.picture&rpar. opcional.  Si <xColumnSayPictures> es una cadena de caracteres&comma. todas las columnas  pueden usar el mismo valor como cadena de molde &lpar.picture&rpar..  Si
<xColumnSayPictures> es un array&comma. cada elemento debe ser una cadena  de caracteres que corresponde a la cadena &lpar.picture&rpar. usada de molde  para la columna con el mismo ndice. Vea la ayuda para @...SAY para  tener
ms informacin acreca de los valores de molde &lpar.picture&rpar..
.br
:p.<xCabeceraColumna> contiene los titulos de cabecera para cada columna  si este es una cadena de caracteres&comma. todas las columnas tendrn el  mismo encabezado&comma. si este es un array&comma. cada elemento es una cadena  de
caracteres que contienen el titulo de cabecera para cada campo.  La cabecera puede ser dividido en ms de una linea al poner un punto  y coma &lpar.&semi.&rpar. en los lugares donde Ud. desea romper la linea.  Si es omitida el
valor por defecto para cada cabecera de columna es  tomado de <acColumnas>  el nombre del campo de la base de datos&comma. si  <acColumnas> no fue especificado
.br
:p.<xSeparadorCabecera> es un array que contiene caracteres que dibujan  las lineas que separan las cabeceras y los datos de los campos .  En lugar de un array Ud. puede usar una cadena de caracteres que  podra ser usada para la
visualizacin de la misma linea para todos  los campos.  El valor por defecto es una linea doble.
.br
:p.<xSeparadorColumna> es un array que contiene caracteres que dibujan  las lineas que separan las columnas visualizadas. En lugar de un array  Ud. puede usar una cadena de caracteres que podria ser usada para la  visualizacin de
la misma linea para todos los campos.  El valor por defecto es una linea simple.
.br
:p.<xSeparadorPie> es un array que contiene caracteres que dibujan  las lineas que separan el area de datos de los campos y el pie.  En lugar de un array Ud. puede usar una cadena de caracteres que  podra ser usada para la
visualizacin de la misma linea para todos  los campos. El valor por defecto es ningn separador de pie.
.br
:p.<xPieColumna> contiene el pie para ser visualizado al final de  cada columna&comma. si este es una cadena de caracteres&comma. todas las columnas  tendran el mismo pie&comma. si este es un array&comma. cada elemento es una cadena
de caracteres que contienen el pie para cada campo. El pie puede ser  dividido en ms de una linea al poner un punto y coma &lpar.&semi.&rpar. en los  lugares donde Ud. desea romper la linea. Si es omitido ningun pie es
visualizado.
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.DBEDIT&lpar.&rpar. retorna .F. si no hay una base de datos abierta en ese area  de trabajo&comma.  si el nmero de columnas para la visualizacin es cero&comma.  en caso contrario DBEDIT&lpar.&rpar. devuelve .T.
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.DBEDIT&lpar.&rpar. visualiza y permite editar registros de una  ms areas de  trabajo en una grilla en pantalla. Cada columna es definida por los  elementos de <acColumnas> y es el equivalente de un campo.  Cada fila es el
equivalente de un registro de la base de datos.
.br
:p.A Continuacin estan las teclas manejadas por DBEDIT&lpar.&rpar.&colon.
:p.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.
&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.  <table>  Tecla            Significado
:row.
:c.
:row.
:c.
:row.
:c.
:row.
:c.
:row.
:c.
:row.
:c.
:row.
:c.
:row.
:c.
:row.
:c.
:row.
:c.
:row.
:c.
:row.
:c.
:row.
:c.
:row.
:c.
:row.
:c.
:etable.
.br
.br
:p.Cuando <xFuncionUsuario> es omitida&comma. dos teclas ms estan activas&colon.  <table>  Tecla            significado
:row.
:c.
:row.
:c.
:row.
:c.
:etable.
.br
:p.Cuando DBEDIT&lpar.&rpar. ejecuta <xFuncionUsuario> le pasa los siguientes  argumentos&colon.  nModo y el ndice del registro actual en <acColumnas>.  Si <acColumnas> es omitido&comma. el nmero de ndice es nmero de
FIELD&lpar.&rpar.  de la estructura de la base de datos abierta.
.br
.br
:p.Valores de los Modos en DBEDIT&lpar.&rpar. &colon.
:p.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.
&minus.  <table>  Dbedit.ch     Valor  Significado
:row.
:c.
:row.
:c.
:row.
:c.
:row.
:c.
:row.
:c.
:etable.
.br
:p.La funcin definida por el usuario  el bloque de cdigo debe retornar  un valor que le indique a DBEDIT&lpar.&rpar. que hacer a continuacin.
.br
:p.Codigos de retorno de la Funcin del Usuario&colon.
:p.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.
&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.
.br
:table cols='10  5 46'.
:row.
:c.Dbedit.ch
:c.Valor
:c.Significado
:row.
:c.
:row.
:c.DE_ABORT
:c.0
:c.Aborta DBEDIT().
:row.
:c.DE_CONT
:c.1
:c.Continua DBEDIT() como ahora.
:row.
:c.DE_REFRESH
:c.2
:c.Fueza relectura/revisualizacin en pantalla de
:row.
:c.
:etable.
.br
.br
:p.La funcin del usuario es llamada una vez en cada uno de los  siguientes casos&colon.  &minus. La base de datos esta vaca.  &minus. El usuario trata de mover ms alla de la parte superior  de la  parte inferior del archivo.
&minus. Interrupcin de teclado&comma. el usuario ha presionado una tecla que no  puede ser manejada por DBEDIT&lpar.&rpar..  &minus. El buffer de teclado esta vaco  un refresco de pantalla acaba  de ocurrir.
.br
:p.Nota Importante&colon.  &minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.  DBEDIT&lpar.&rpar. es una funcin de compatibilidad&comma. esta fu superada por la  clase TBrowse
y no es recomendada para nuevas aplicaciones.
.br
.br
:hp2.Examples:ehp2.
.br
:p.
:lm margin=6.
.br
      &slash.&slash. Despliega un archivo DBF usando valores por defecto
.br
      USE Test
.br
      DBEDIT&lpar.&rpar.
.br
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Started
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.<xFuncionUsuario> puede ser tambin un bloque de cdigo&comma. esta es una  extensin de Harbour.
.br
:p.CA&minus.Clipper lanzar un error si no hay una base de datos abierta  Harbour puede retornar .F.
.br
:p.Clipper es inconsistente y lanzar un error si el nmero de columnas  es cero. Harbour puede retornar .F.  Las NG de CA&minus.Clipper 5.2 indican que el valor devuelto es NIL&comma.  esto es errneo y debera ser un valor lgico.
.br
:p.Hay un cdigo de retorno &lpar.3&rpar. indocumentado para las funciones  definidas por el usuario en Clipper &lpar.ambos 87 and 5.x&rpar.. este es un  Modo de agregado &lpar.Append&rpar. el cual&colon.  &cdq.Divide la pantalla
para permitir ms que datos sean agregados en el  area de la ventana&cdq..  Este modo no es soportado por Harbour.
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.Los archivos de cabecera son dbedit.ch&comma. inkey.ch  La librera es rtl
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=39.@...SAY:elink.
.br
:link reftype=hd res=40.BROWSE():elink.
.br
:link reftype=hd res=41.TBROWSE CLASS:elink.
.br
:link reftype=hd res=42.TRANSFORM():elink.
.br
:h2 id=ENTRY res=40.BROWSE()
:i2 refid=ENTRAX.BROWSE()
:p.BROWSE&lpar.&rpar.
.br
.br
:hp2.Despliega un archivo de base de datos:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.BROWSE&lpar. &lbrk.<nSup>&comma. <nIzq>&comma. <nInf>&comma. <nDer>&rbrk.. &rpar. &minus.&minus.> lExito:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<nSup> coordenada de la fila Superior de visualizacin.
.br
:p.<nIzq> coordenada de la columna izquierda de visualizacin.
.br
:p.<nInf> coordenada de la fila inferior de visualizacin.
.br
:p.<nDer> coordenada de la columna derecha de visualizacin.
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.BROWSE&lpar.&rpar. retorna .F. si no hay una base de datos abierta en ese area  de trabajo&comma. en caso contrario devuelve .T.
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.BROWSE&lpar.&rpar. es un visualizador de bases de datos de propsito general&comma.  sin demasiado trabajo ud. puede desplegar un archivo DBF con las  siguientes teclas&colon.
.br
:table cols='14 47'.
:row.
:c.Tecla
:c.Significado
:row.
:c.
:row.
:c.Izquierda
:c.Mueve una columna a la izquierda (campo previo)
:row.
:c.Derecha
:c.Mueve una columna a la derecha (proximo campo)
:row.
:c.Arriba
:c.Mueve arriba una fila (registro previo)
:row.
:c.Abajo
:c.Mueve abajo una fila (proximo registro)
:row.
:c.Pag-Arriba
:c.Mueve a la pantalla previa
:row.
:c.Pag-Abajo
:c.Mueve a la pantalla proxima
:row.
:c.
:c.Ctrl Pag-Arriba  Mueve al inicio del archivo
:row.
:c.Ctrl Pag-Abajo
:c.Mueve al final del archivo
:row.
:c.Inicio
:c.Mueve a la columna visible ms a la izquierda
:row.
:c.Fin
:c.Mueve a la columna visible ms a la derecha
:row.
:c.Ctrl Izquierda
:c.Desplaza una columna a la izquierda
:row.
:c.Ctrl Derecha
:c.Desplaza una columna a la deecha
:row.
:c.Ctrl Inicio
:c.Mueve a la columna ms a la izquierda
:row.
:c.Ctrl Fin
:c.Mueve a la columna ms a la derecha
:row.
:c.Esc
:c.Termina el BROWSE()
:etable.
.br
.br
:p.En la parte superior de la pantalla ud. ve una linea de estado con  la siguiente indicacin&colon.
.br
:row.
:c.
:row.
:c.
:row.
:c.
:row.
:c.
:row.
:c.
:etable.
.br
.br
:p.Ud. debera pasar las cuatro coordenadas validas&comma. si menos de cuatro  parmetros son pasados al BROWSE&lpar.&rpar. las coordenadas por defecto son&colon.  1&comma. 0&comma. MAXROW&lpar.&rpar.&comma. MAXCOL&lpar.&rpar..
.br
.br
:hp2.Examples:ehp2.
.br
:p.
:lm margin=6.
.br
      &slash.&slash. muestra como desplegar una base de datos
.br
      USE Test
.br
      BROWSE&lpar.&rpar.
.br
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Started
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.La librera es rtl
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=38.DBEDIT()*:elink.
.br
:link reftype=hd res=41.TBROWSE CLASS:elink.
.br
:h1 CLASY.CLASE TBROWSE
:h2  res=43.TBrowseDB()
:i1 id=CLASEX.CLASE TBROWSE
:i2 refid=CLASEX.TBROWSEDB()
:p.TBrowseDB&lpar.&rpar.
.br
.br
:hp2.Crea un nuevo objeto TBrowse para ser usado con una base de datos.:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.TBrowseDB&lpar. &lbrk.<nSup>&rbrk..&comma. &lbrk.<nIzq>&rbrk..&comma. &lbrk.<nInf>&rbrk..&comma. &lbrk.<nDer>&rbrk.. &rpar. &minus.&minus.> oBrowse:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<nSup> coordenada de la fila superior de visualizacin.
.br
:p.<nIzq> coordenada de la columna izquierda de visualizacin.
.br
:p.<nInf> coordenada de la fila inferior de visualizacin.
.br
:p.<nDer> coordenada de la columna derecha de visualizacin.
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.TBrowseDB&lpar.&rpar. retorna un nuevo objeto TBrowse con unas coordenadas  especficas y un &colon.SkipBlock&comma. &colon.GoTopBlock y &colon.GoBottomBlock por defecto  para desplegar una base de datos.
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.TBrowseDB&lpar.&rpar. es una forma rpida de crear un objeto TBrowse junto con  el soporte mnimo para desplegar una base de datos.  Note que el objeto TBrowse devuelto no contiene objetos TBColumn y Ud.  necesita agregar una
columna para cada campo por Ud. mismo
.br
.br
:hp2.Examples:ehp2.
.br
:p.
:lm margin=6.
.br
      Para un buen ejemplo&comma. mire en el cdigo fuente de la funcin BROWSE&lpar.&rpar.
.br
      en el subdirectorio ..&slash.source&slash.rtl&slash.browse.prg
.br
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Started
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.TBrowseDB&lpar.&rpar. funciona exactamente como la funcin de CA&minus.Clipper TBrowseDB&lpar.&rpar..
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.La librera es rtl
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=40.BROWSE():elink.
.br
:link reftype=hd res=44.TBCOLUMN CLASS:elink.
.br
:link reftype=hd res=41.TBROWSE CLASS:elink.
.br
:link reftype=hd res=45.TBROWSENEW():elink.
.br
:h1 BASEY.BASE DE DATOS
:h2  res=46.dbSkipper()
:i1 id=BASEX.BASE DE DATOS
:i2 refid=BASEX.DBSKIPPER()
:p.dbSkipper&lpar.&rpar.
.br
.br
:hp2.Funcin para ayudar a saltar registros en la base de datos:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.dbSkipper&lpar. <nRecs> &rpar. &minus.&minus.> nSkipped:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<nRecs> es el nmero de registros a saltar relativos al registro actual.  Nmeros positivos tratan de mover el puntero de registro hacia adelante  y Nmeros negativos tratan de mover el puntero de registro hacia atras  <nRecs>
registros.
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.dbSkipper&lpar.&rpar. retorna el nmero actual de registros saltados.
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.dbSkipper&lpar.&rpar. es una funcin de ayuda usada en el mecanismo de despliegue  para saltar un nmero de registros mientras le da al llamador una  indicacin del nmero actual de registros saltados.
.br
.br
:hp2.Examples:ehp2.
.br
:p.
:lm margin=6.
.br
      &slash.&slash. Abre un archivo y chequea si tenemos suficientes registros en el
.br
      USE ventas
.br
      IF dbSkipper&lpar. 100 &rpar. &eq.&eq. 100
.br
         ? &cdq.Buen trabajo!&comma. debes irte de fiesta&cdq.
.br
      ELSE
.br
         ? &cdq.Muy mal&comma. Ud. debera realmente trabajar ms duro&cdq.
.br
      ENDIF
.br
      CLOSE
.br
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.dbSkipper&lpar.&rpar. es una funcin de compatibilidad con XBase++ y no existe  como una funcin estndar en CA&minus.Clipper 5.x  Esta funcin es solamente visible si el archivo&colon.  ..&slash.source&slash.rtl&slash.browdb.prg
fue compilado con la bandera HB&us.COMPAT&us.XPP.
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.La librera es rtl
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=47.DBSKIP():elink.
.br
:link reftype=hd res=48.SKIP:elink.
.br
:h1 COMAY.COMANDO OOP
:h2  res=49.CLASS
:i1 id=COMANX.COMANDO OOP
:i2 refid=COMANX.CLASS
:p.CLASS
.br
.br
:hp2.Define una Clase para la Programacin Orientada a Objetos &lpar.OOP&rpar..:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.CLASS <NombreClase> &lbrk. <FROM&comma. INHERIT> <SuperClase> &rbrk..:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<NombreClase> Nombre de la clase a definir. Por tradicin&comma. las clases  en Harbour comienzan con &cdq.T&cdq. &lpar.algo comn en el mundo OOP&rpar.  para evitar colisiones con clases creadas por el usuario.  <SuperClase> La
clase padre para usar la herencia.
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.CLASS crea una clase desde la cual se pueden crear objetos.  Cada clase es definida en un archivo.PRG separado para este propsito  No se puede crear ms de una clase en un archivo.PRG  Despus del mandato CLASS comienza la
definicin&comma. luego los elementos  DATA &lpar.tambien conocidos como variables de instancia&rpar. y luego  los METHODS de la clase &lpar.el equivalente a las funciones en la  programacin tradicional&rpar.
.br
:p.Las Clases pueden heredar desde una clase sola <SuperClass>&comma. pero la  cadena de herencia puede extenderse a muchos niveles
.br
:p.Un program usa una clase llamando al Constructor de la clase&comma. el  mtodo New&lpar.&rpar. para crear el objeto. Ese objeto es usualmente asignado  a una variable&comma. la cual es usada para acceder a los elementos DATA y  a
los mtodos
.br
.br
:hp2.Examples:ehp2.
.br
:p.
:lm margin=6.
.br
      CLASS TBColumn
.br

.br
         DATA Block      &slash.&slash. Codeblock para recuperar datos para la Columna
.br
         DATA Cargo      &slash.&slash. Variable definida por el usuario
.br
         DATA ColorBlock &slash.&slash. Codeblock que determina el color de los items
.br
         DATA ColSep     &slash.&slash. Caracter separador de la Columna
.br
         DATA DefColor   &slash.&slash. Array de ndices numricos a la tabla de color
.br
         DATA Footing    &slash.&slash. Pie de Columna
.br
         DATA FootSep    &slash.&slash. Caracter separador del Pie
.br
         DATA Heading    &slash.&slash. Encabezado de la Columna
.br
         DATA HeadSep    &slash.&slash. Caracter separador de la cabecera
.br
         DATA Width      &slash.&slash. Ancho de la Columna
.br
         DATA ColPos     &slash.&slash. Posicin temporaria de la columna en pantalla
.br

.br
         METHOD New&lpar.&rpar.    &slash.&slash. Constructor
.br

.br
      ENDCLASS
.br
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.CLASS es una extensin de Harbour.
.br
.br
:hp2.Platforms:ehp2.
.br
:p.
:lm margin=6.
:p.Todas
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=50.TCLASS():elink.
.br
:link reftype=hd res=51.PROGRAMACIN ORIENTADA A OBJETO:elink.
.br
:link reftype=hd res=52.DATA:elink.
.br
:link reftype=hd res=53.METHOD:elink.
.br
:h2 id=COMAY res=52.DATA
:i2 refid=COMANX.DATA
:p.DATA
.br
.br
:hp2.Define una variable de instance DATA&comma. para los objetos de una clase:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.DATA <NombreDato1> &lbrk.&comma.<NombreDatoN>&rbrk.. &lbrk. AS <tipo> &rbrk.. &lbrk. INIT <uValor> &rbrk..:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<NombreDato1> Nombre de DATA
.br
:p.<tipo>        Especificacin Opcional del tipo de datos&comma. de uno de  los siguientes &lpar.especificacin en ingls&rpar.&colon.  Character&comma. Numeric&comma. Date&comma. Logical&comma. Codeblock&comma. Nil
.br
:p.<uValor>      Valor opcional inicial cuando se crea un nuevo objeto
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.Los elementos DATA tambien pueden ser pensados como &cdq.propiedades&cdq.   &cdq.atributos&cdq. de un objeto. ellos pueden ser de cualquier tipo  incluyendo bloques de codigo.  Una vez que el objeto ha sido creado&comma. los
elementos DATA son referen&minus.  ciados con dos puntos &lpar.&colon.&rpar. como en MyObject&colon.Heading &colon.&eq. &cdq.Nombre&cdq..  Usualmente una clase tambin define mtodos para manipular los DATA.
.br
:p.Se puede usar la clausula &cdq.AS <type>&cdq. para reforzar que DATA es  perteneciente a un cierto tipo. De otra manera este tomar el tipo  de cualquier valor que le sea asignado.
.br
:p.Use la clausula &cdq.INIT <uValue>&cdq. para inicializar ese DATA a <uValue>  siempre que un nuevo objeto es creado.
.br
.br
:hp2.Examples:ehp2.
.br
:p.
:lm margin=6.
.br
      CLASS TBColumn
.br

.br
         DATA Block      &slash.&slash. Codeblock para recuperar datos para la Columna
.br
         DATA Cargo      &slash.&slash. Variable definida por el usuario
.br
         DATA ColorBlock &slash.&slash. Codeblock que determina el color de los items
.br
         DATA ColSep     &slash.&slash. Caracter separador de la Columna
.br
         DATA DefColor   &slash.&slash. Array de ndices numricos a la tabla de color
.br
         DATA Footing    &slash.&slash. Pie de Columna
.br
         DATA FootSep    &slash.&slash. Caracter separador del Pie
.br
         DATA Heading    &slash.&slash. Encabezado de la Columna
.br
         DATA HeadSep    &slash.&slash. Caracter separador de la cabecera
.br
         DATA Width      &slash.&slash. Ancho de la Columna
.br
         DATA ColPos     &slash.&slash. Posicin temporaria de la columna en pantalla
.br

.br
         METHOD New&lpar.&rpar.    &slash.&slash. Constructor
.br

.br
      ENDCLASS
.br
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.DATA es una extensin de Harbour.
.br
.br
:hp2.Platforms:ehp2.
.br
:p.
:lm margin=6.
:p.Todas
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=51.PROGRAMACIN ORIENTADA A OBJETO:elink.
.br
:link reftype=hd res=49.CLASS:elink.
.br
:link reftype=hd res=53.METHOD:elink.
.br
:link reftype=hd res=54.CLASSDATA:elink.
.br
:h2 id=COMAY res=54.CLASSDATA
:i2 refid=COMANX.CLASSDATA
:p.CLASSDATA
.br
.br
:hp2.Define una variable CLASSDATA para una clase &lpar.NO para un Objeto !&rpar.:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.CLASSDATA <DataName1> &lbrk.&comma.<DataNameN>&rbrk.. &lbrk. AS <type> &rbrk.. &lbrk. INIT <uValue> &rbrk..:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<NombreDato1> Nombre de DATA
.br
:p.<tipo>        Especificacin opcional del tipo de datos de uno de  los siguientes &lpar.Original en ingls&rpar.&colon.  Character&comma. Numeric&comma. Date&comma. Logical&comma. Codeblock&comma. Nil
.br
:p.<uValor>      Valor opcional inicial cuando se inicia el programa
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.Las variables CLASSDATA pueden se pensadas como &cdq.propiedades&cdq. de un  clase entera. Cada CLASSDATA existe slo una vez&comma. no importa cuntos  objetos sean creados. Un uso comun es para un contador que es  incrementado
siempre que un objeto es creado y decrementado cuando  alguno es destruido&comma. as se puede monitorear el nmero de objetos en  existencia para esta clase.
.br
:p.Se puede usar la clausula &cdq.AS <type>&cdq. para reforzar que CLASSDATA es  perteneciente a un cierto tipo. De otra manera este tomar el tipo  de cualquier valor que le sea asignado.  Use la clausula &cdq.INIT <uValue>&cdq.
para inicializar ese DATA a <uValue>  siempre que un nuevo objeto es creado.
.br
.br
:hp2.Examples:ehp2.
.br
:p.
:lm margin=6.
.br
      CLASS TWindow
.br
         DATA   hWnd&comma. nOldProc
.br
         CLASSDATA lRegistered AS LOGICAL
.br
      ENDCLASS
.br
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.CLASSDATA es una extensin de Harbour.
.br
.br
:hp2.Platforms:ehp2.
.br
:p.
:lm margin=6.
:p.Todas
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=51.PROGRAMACIN ORIENTADA A OBJETO:elink.
.br
:link reftype=hd res=49.CLASS:elink.
.br
:link reftype=hd res=53.METHOD:elink.
.br
:link reftype=hd res=52.DATA:elink.
.br
:h2 id=COMAY res=53.METHOD
:i2 refid=COMANX.METHOD
:p.METHOD
.br
.br
:hp2.Declara un METHOD &lpar.mtodo&rpar. para una clase en la cabecera de la clase:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.METHOD <NombreMtodo>&lpar. &lbrk.<params&comma....>&rbrk.. &rpar. &lbrk. CONSTRUCTOR &rbrk..:ehp2.
:p.:hp2.METHOD <NombreMtodo>&lpar. &lbrk.<params&comma....>&rbrk.. &rpar. INLINE <Code&comma....>:ehp2.
:p.:hp2.METHOD <NombreMtodo>&lpar. &lbrk.<params&comma....>&rbrk.. &rpar. BLOCK  <CodeBlock>:ehp2.
:p.:hp2.METHOD <NombreMtodo>&lpar. &lbrk.<params&comma....>&rbrk.. &rpar. EXTERN <FuncName>&lpar.&lbrk.<args&comma....>&rbrk..&rpar.:ehp2.
:p.:hp2.METHOD <NombreMtodo>&lpar. &lbrk.<params&comma....>&rbrk.. &rpar. SETGET:ehp2.
:p.:hp2.METHOD <NombreMtodo>&lpar. &lbrk.<params&comma....>&rbrk.. &rpar. VIRTUAL:ehp2.
:p.:hp2.METHOD <NombreMtodo>&lpar. &lbrk.<param>&rbrk.. &rpar.      OPERATOR <op>:ehp2.
:p.:hp2.METHOD <NombreMtodo>&lpar. &lbrk.<params&comma....>&rbrk.. &rpar. CLASS <ClassName>:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<NombreMtodo>  Nombre del mtodo a definir
.br
:p.<params&comma....>    Lista opcional de parametros
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.Los Mtodos son &cdq.funciones de clase&cdq. y hacen el trabajo de la clase.  Todos los mtodos pueden ser definidos en la cabecera entre los  comandos CLASS y ENDCLASS. Si el cuerpo de un mtodo no esta totalmente  definido
aqui&comma. el cuerpo completo es escrito debajo del comando  ENDCLASS usando esta sintaxis&colon.
.br
:p.METHOD <NombreMtodo>&lpar. &lbrk.<params&comma....>&rbrk.. &rpar. CLASS <NombreClase>
.br
:p.Los Mtodos pueden referenciar al objeto actual usando la palabra  clave &cdq.Self&colon.&cdq.  su versin ms corta &cdq.&colon.&colon.&cdq.
.br
:p.CLAUSULAS&colon.
.br
:p.CONSTRUCTOR  Define un mtodo especial de la clase&colon. el mtodo  Constructor&comma. usado para crear objetos. Este es  usualmente el mtodo New&lpar.&rpar..  Los constructores siempre retornan el objeto New&lpar.&rpar..
.br
:p.INLINE       Rpido y fcil de codificar&comma. INLINE le permite definir  el cdigo para el mtodo inmediatamente despus de la  definicin de la clase. Cualquier mtodo no declarado  INLINE  BLOCK debe ser completamente
definido despus  del comando ENDCLASS.  El <Codigo&comma....> siguiente a INLINE recibe un parametro  de Self. Si se necesita recibir ms parmetros&comma. use  la clusula BLOCK en su lugar.
.br
:p.BLOCK        Use esta clusula cuando desee declarar rpidos mtodos  'inline' que necesiten parmetros. El primer parmetro  a <CodeBlock> debe ser Self&comma. como en&colon.
.br
:p.METHOD <NombreMtodo> BLOCK &lbrc.&splitvbar.Self&comma.<arg1>&comma.<arg2>&comma....&comma.<argN>&splitvbar....&rbrc.
.br
:p.EXTERN       Si una funcin externa hace lo que el mtodo necesita&comma.  use esta clusula para hacer una llamada optimizada a  esa funcin directamente.
.br
:p.SETGET       Para datos calculados. El nombre del mtodo puede ser  manipulado como un elemento de DATA para establecer  &lpar.Set&rpar. u obtener &lpar.Get&rpar. un valor.
.br
:p.VIRTUAL      Mtodos que no hacen nada. Utiles para Clases de Base  donde la Clase hija definir el comportamiento del mtodo&comma.   cuando Ud. esta creando y probando una Clase.
.br
:p.OPERATOR     Operador de Sobrecarga para las Clases.  Vea el ejemplo ..&slash.Tests&slash.TestOp.prg para detalles
.br
:p.CLASS <ClassName>  Use esta sintaxis solamente para definir un mtodo  completo despus del comando ENDCLASS.
.br
.br
:hp2.Examples:ehp2.
.br
:p.
:lm margin=6.
.br
      CLASS TWindow
.br
         DATA   hWnd&comma. nOldProc
.br
         METHOD New&lpar. &rpar. CONSTRUCTOR
.br
         METHOD Capture&lpar.&rpar. INLINE  SetCapture&lpar. &colon.&colon.hWnd &rpar.
.br
         METHOD End&lpar.&rpar. BLOCK  &lbrc. &splitvbar. Self&comma. lEnd &splitvbar. If&lpar. lEnd &colon.&eq. &colon.&colon.lValid&lpar.&rpar.&comma.&semi.
.br
                                 &colon.&colon.PostMsg&lpar. WM&us.CLOSE &rpar.&comma.&rpar.&comma. lEnd &rbrc.
.br
         METHOD EraseBkGnd&lpar. hDC &rpar.
.br
         METHOD cTitle&lpar. cNewTitle &rpar. SETGET
.br
         METHOD Close&lpar.&rpar. VIRTUAL
.br
      ENDCLASS
.br

.br
      METHOD New&lpar. &rpar. CLASS TWindow
.br
         local nVar&comma. cStr
.br
         ... <codigo> ...
.br
         ... <codigo> ...
.br
      RETURN Self
.br
.br
.br
:hp2.Tests:ehp2.
.br
:p.
:lm margin=6.
.br
      TestOp.prg
.br
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.METHOD es una extensin de Harbour.
.br
.br
:hp2.Platforms:ehp2.
.br
:p.
:lm margin=6.
:p.Todas
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=50.TCLASS():elink.
.br
:link reftype=hd res=51.PROGRAMACIN ORIENTADA A OBJETO:elink.
.br
:link reftype=hd res=52.DATA:elink.
.br
:link reftype=hd res=49.CLASS:elink.
.br
:h2 id=COMAY res=55.MESSAGE
:i2 refid=COMANX.MESSAGE
:p.MESSAGE
.br
.br
:hp2.Reenva la llamada a un mtodo a otro mtodo.:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.MESSAGE <NombreMensaje>   METHOD <NombreMtodo>&lpar. &lbrk.<params&comma....>&rbrk.. &rpar.:ehp2.
:p.:hp2.MESSAGE <NombreMensaje>&lpar.&rpar. METHOD <NombreMtodo>&lpar. &lbrk.<params&comma....>&rbrk.. &rpar.:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<NombreMensaje>  El nombre del pseudo&minus.mtodo a definir.
.br
:p.<NombreMtodo>   El mtodo a crear y llamar cuando <NombreMensaje>  es invocado.  <params&comma....>     Lista de parmetros opcionales para el mtodo
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.El comando MESSAGE es una caracterstica rara vez usada&comma. que permite  re&minus.enviar una llamada a un mtodo con un nombre diferente. Esto puede  ser necesario si el nombre de un mtodo entra en conflicto con una  funcin
pblica que necesita ser llamada desde adentro de un mtodo  de la Clase.
.br
:p.Por ejemplo&comma. se puede tener una funcin pblica llamda BeginPaint&lpar.&rpar.  que es usada para pintar las ventanas. Podra ser natural tambin  tener un mtodo de la Clase Ventana&comma. llamado
&colon.BeginPaint&lpar.&rpar. que la  aplicacin pueda llamar.  Pero dentro del mtodo de la Clase uno podra no estar habilitado  para llamar a la funcin pblica porque&comma. los mtodos internos estn  basados en funciones
estticas &lpar.las que ocultan funciones pblicas  con el mismo nombre&rpar.
.br
:p.El comando MESSAGE permite crear el verdadero mtodo con un nombre  diferente &lpar.&colon.&colon.xBeginPaint&lpar.&rpar.&rpar.&comma. y an permitir la sintaxis &colon.&colon.BeginPaint&lpar.&rpar.  para llamar a
&colon.&colon.xBeginPaint&lpar.&rpar.. Este entonces es libre de llamar a  a la funcin publica BeginPaint&lpar.&rpar..
.br
.br
:hp2.Examples:ehp2.
.br
:p.
:lm margin=6.
.br
      CLASS TWindow
.br
         DATA   hWnd&comma. nOldProc
.br
         METHOD New&lpar. &rpar.  CONSTRUCTOR
.br
         MESSAGE BeginPaint METHOD xBeginPaint&lpar.&rpar.
.br
      ENDCLASS
.br
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.MESSAGE es una extensin de Harbour.
.br
.br
:hp2.Platforms:ehp2.
.br
:p.
:lm margin=6.
:p.Todas
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=53.METHOD:elink.
.br
:link reftype=hd res=52.DATA:elink.
.br
:link reftype=hd res=49.CLASS:elink.
.br
:link reftype=hd res=51.PROGRAMACIN ORIENTADA A OBJETO:elink.
.br
:h2 id=COMAY res=56.ERROR HANDLER
:i2 refid=COMANX.ERROR HANDLER
:p.ERROR HANDLER
.br
.br
:hp2.Designa un mtodo como manejador de error para la Clase.:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.ERROR HANDLER <NombreMtodo>&lpar. &lbrk.<params&comma....>&rbrk.. &rpar.:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<NombreMtodo>  Nombre del mtodo a definir
.br
:p.<params&comma....>    Lista de parametros opcionales
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.ERROR HANDLER nombra al mtodo que deberia manejar los errores para  la Clase que esta siendo definida.
.br
.br
:hp2.Examples:ehp2.
.br
:p.
:lm margin=6.
.br
      CLASS TWindow
.br
         ERROR HANDLER  MyErrHandler&lpar.&rpar.
.br
      ENDCLASS
.br
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.ERROR HANDLER es una extensin de Harbour.
.br
.br
:hp2.Platforms:ehp2.
.br
:p.
:lm margin=6.
:p.Todas
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=57.OBJECT ORIENTED PROGRAMMING:elink.
.br
:link reftype=hd res=58.ON ERROR:elink.
.br
:link reftype=hd res=49.CLASS:elink.
.br
:link reftype=hd res=53.METHOD:elink.
.br
:link reftype=hd res=52.DATA:elink.
.br
:h2 id=COMAY res=58.ON ERROR
:i2 refid=COMANX.ON ERROR
:p.ON ERROR
.br
.br
:hp2.Designa un mtodo como manejador de error para la Clase.:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.ON ERROR <NombreMtodo>&lpar. &lbrk.<params&comma....>&rbrk.. &rpar.:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<NombreMtodo>  Nombre del mtodo a definir
.br
:p.<params&comma....>    Lista de parametros opcionales
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.ON ERROR es un sinnimo para ERROR HANDLER.  Este nombra al mtodo que debera manejar los errores para la  Clase que esta siendo definida.
.br
.br
:hp2.Examples:ehp2.
.br
:p.
:lm margin=6.
.br
      CLASS TWindow
.br
         ON ERROR  MyErrHandler&lpar.&rpar.
.br
      ENDCLASS
.br
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.ON ERROR es una extensin de Harbour.
.br
.br
:hp2.Platforms:ehp2.
.br
:p.
:lm margin=6.
:p.Todas
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=51.PROGRAMACIN ORIENTADA A OBJETO:elink.
.br
:link reftype=hd res=56.ERROR HANDLER:elink.
.br
:link reftype=hd res=49.CLASS:elink.
.br
:link reftype=hd res=53.METHOD:elink.
.br
:link reftype=hd res=52.DATA:elink.
.br
:h2 id=COMAY res=59.ENDCLASS
:i2 refid=COMANX.ENDCLASS
:p.ENDCLASS
.br
.br
:hp2.Termina la declaracin de una Clase.:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.ENDCLASS:ehp2.
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.ENDCLASS marca el fin de la declaracin de una Clase.  Este es usualmente seguido por el mtodo de la Clase que no es INLINE.
.br
.br
:hp2.Examples:ehp2.
.br
:p.
:lm margin=6.
.br
      CLASS TWindow
.br
         DATA   hWnd&comma. nOldProc
.br
      ENDCLASS
.br
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.ON ERROR es una extensin de Harbour.
.br
.br
:hp2.Platforms:ehp2.
.br
:p.
:lm margin=6.
:p.Todas
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=51.PROGRAMACIN ORIENTADA A OBJETO:elink.
.br
:link reftype=hd res=49.CLASS:elink.
.br
:link reftype=hd res=53.METHOD:elink.
.br
:link reftype=hd res=52.DATA:elink.
.br
:h1 DOCUY.DOCUMENTACIN
:h2  res=60.Opciones del Compilador
:i1 id=DOCUMX.DOCUMENTACIN
:i2 refid=DOCUMX.OPCIONES DEL COMPILADOR
:p.Opciones del Compilador
.br
.br
:hp2.Opciones del Compilador:ehp2.
.br
:p.
:lm margin=6.
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
.br
:p.Invocando al compilador Harbour&colon.
:p.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.
.br
:p.harbour <archivo&lbrk..prg&rbrk..> &lbrk.opciones&rbrk..
:p.or
:p.harbour &lbrk.opciones&rbrk.. <archivo&lbrk..prg&rbrk..>
:p.or
:p.harbour &lbrk.opciones&rbrk.. <archivo&lbrk..prg&rbrk..> &lbrk.opciones&rbrk..
.br
.br
:p.Las opciones de la lnea de comandos debe ser separada&comma. al menos por  un espacio en blanco. 	
:p.Las opciones pueden comenzar con el carcter '&slash.'  '&minus.'&comma.
.br
:p.Opciones de la lnea de comandos de&colon.
:p.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.
.br
:p.&slash.a               Declaracin Automtica de memvar
:p.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.
:p.Esto causa que todas las variables declaradas por las sentencias  PARAMETER&comma. PRIVATE  PUBLIC sean automticamente declaradas como  variables MEMVAR.
.br
:p.&slash.b               Informacin de depuracin &lpar.Bug&rpar.
:p.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.
:p.El compilador genera toda la informacin requerida para depuracin
.br
:p.&slash.d<id>&lbrk.&eq.<val>&rbrk..   #define <id>
:p.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.
.br
:p.&slash.es&lbrk.<nivel>&rbrk..     establece la Severidad de la salida &lpar.Exit Severity&rpar.
:p.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.
.br
:p.&slash.es or &slash.es0 &minus. Todas las advertencias son ignoradas y el cdigo de  salida retornado por el compilador &lpar.accedido por el  comando de DOS ERRORLEVEL&rpar. es igual a cero si no  hay errores en el archivo
fuente compilado.
:p.&slash.es1        &minus. Cualquier advertencia genera un cdigo de salida  distinto de cero&comma. pero la salida es an creada.
:p.&slash.es2        &minus. Cualquier advertencia es tratada como error y ningn  archivo de salida es creado. El cdigo de salida es  establecido a un valor distinto de cero.
.br
:p.&slash.g<tipo>         Generacin del tipo de archivo de salida <type>
:p.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.
.br
:p.&slash.gc          tipo de salida&colon. fuente de lenguaje C &lpar..c&rpar. &lpar.defecto&rpar.
:p.&slash.gf          tipo de salida&colon. Windows&slash.DOS OBJ32 &lpar..obj&rpar.
:p.&slash.gh          tipo de salida&colon. Objeto Portable de Harbour &lpar..hrb&rpar.
:p.&slash.gj          tipo de salida&colon. fuente de Java &lpar..java&rpar.
:p.&slash.gp          tipo de salida&colon. fuente de Pascal &lpar..pas&rpar.
:p.&slash.gr          tipo de salida&colon. recursos de Windows &lpar..rc&rpar.
.br
:p.&slash.i<ruta>         agrega la ruta de bsqueda de archivos #Include
:p.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.
.br
:p.&slash.l               suprime la informacin del nmero de Lnea
:p.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.
:p.El compilador no genera el nmero de lnea del cdigo fuente  en el archivo de salida. La funcin PROCLINE&lpar.&rpar. retornar cero  para los mdulos compilados usando esta opcin.
.br
:p.&slash.m               compilar el Mdulo actual solamente
:p.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.
.br
:p.&slash.n               sin procedimiento de inicio implcito
:p.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.
:p.El compilador no crea un procedimiento con el mismo nombre  que el del archivo compilado.  Esto significa que algunas  declaraciones puestas antes de la primera sentencia de  PROCEDURE  FUNCTION tienen el alcance del archivo y
pueden ser  accedidas&slash.usadas en todas las funciones&slash.procedimientos definidos  en el archivo fuente compilado. Todas las sentencias ejecutables  puestas al principio del archivo y antes de la primera sentencia  de
PROCEDURE  FUNCTION son ignoradas.
.br
:p.&slash.o<ruta>         unidad de disco y&slash.o ruta para el archivo de salida
:p.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.
.br
:p.&slash.p               genera un archivo de salida Pre&minus.procesada &lpar..ppo&rpar.
:p.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.
:p.El compilador solamente crea el archivo que contiene el  resultado del archivo fuente pre&minus.procesado.
.br
:p.&slash.q               Quieto
:p.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.
:p.El compilador no imprime ningn mensaje durante la compilacin  &lpar.excepto la informacin del copyright&rpar..
.br
:p.&slash.q0          que permanezca realmente Quieto y no muestre ni  siquiera la informacin del copyright.
.br
:p.&slash.r&lbrk.<libreria>&rbrk..   solicita al linker Revisar por <libreria> &lpar. ninguna&rpar.
:p.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.
:p.Actualmente no soportado en Harbour.
.br
:p.&slash.s               solo chequeo de Sintaxis.
:p.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.
:p.El compilador chequea la sintaxis solamente. Ningn archivo de  salida es generado.
.br
:p.&slash.t<ruta>         ruta para la creacin de un archivo Temporario
:p.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.
:p.Actualmente no usado en harbour &lpar.El compilador de harbour no  crea ningn archivo temporal&rpar.
.br
:p.&slash.u&lbrk.<archivo>&rbrk..       Usar la definicin de comando establecido en el  <archivo> &lpar. ninguno&rpar.
:p.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.
:p.An no soportado.
.br
:p.&slash.v               las Variables son asumidas como M&minus.>
:p.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.
:p.Todas las variables sin declarar  unaliased son asumidas como  variables MEMVAR &lpar.variables privadas  pblicas&rpar.. si este switch  no es usado entones el alcance de estas variables es chequeado  en tiempo de ejecucin.
.br
:p.&slash.w&lbrk.<nivel>&rbrk..      Establece el nmero de nivel de las advertencias  &lpar.Warnings&rpar. &lpar.0..4&comma. por defecto es 1&rpar.
:p.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.
.br
:p.&slash.w0         &minus. sin advertencias			
:p.&slash.w or &slash.w1   &minus. advertencias compatibles con Clipper
:p.&slash.w2         &minus. algunas advertencias tiles ausentes en Clipper
:p.&slash.w3         &minus. advertencias generadas para extensiones al lenguaje  hechas en Harbour. Tambin habilita el chequeo de  sintaxis fuertemente tipeada pero slo advierte  contra los tipos declarados&comma. o los tipos que
pueden  ser calculados en tiempo de compilacin.
:p.&slash.w4         &minus. habilita advertencias acerca de operaciones que son  sospechosas&comma. lo cual significa que si se mezclan tipos  sin declarar  tipos que no pueden ser calculados  en tiempo de compilacin&comma. junto
con los tipos ya  declarados&comma. una advertencia ser generada.
.br
:p.&slash.x&lbrk.<prefijo>&rbrk..    establece el smbolo del prefijo agregado al nombre  de funcin &lpar.para archivo.c solamente&rpar.
:p.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.
:p.Establece el smbolo del prefijo agregado al nombre de funcin  de inicio &lpar.en la salida de lenguaje C&comma. actualmente&rpar.. Esta funcin  es generada automticamente para cada mdulo de PRG compilado.  Este prefijo
adicional puede ser usado para suprimir problemas  con smbolos duplicados durante el enlazado de una aplicacin  &lpar.linking&rpar. con alguna librera de terceros.
.br
:p.&slash.y               seguimiento de la actividad de Lex &amp. Yacc
:p.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.
:p.El compilador Harbour usa las utilidades FLEX y YACC para analizar  el cdigo fuente y generar el archivo de salida requerido.  Esta opcin sigue la actividad de esas utilidades.
.br
:p.&slash.z               suprime el cortocircuito lgico &lpar..and. y .or.&rpar.
:p.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.
.br
:p.&slash.10              restringe la longitud de smbolos a 10 caracteres.
:p.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.
:p.Todos los nombres de variables y de funciones son cortados a un  mximo de 10 caracteres.
.br
.br
:p.Compilacin en modo lote &lpar.batch&rpar..
:p.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.
.br
:p.@<archivo>         compila la lista de mdulos en el <archivo>
:p.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.
:p.No soportado an.
.br
.br
.br
:p.Conocidas incompatibilidades entre compiladores harbour y clipper
:p.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.
&eq.&eq.&eq.&eq.&eq.&eq.&eq.&eq.
.br
:p.NOTE&colon.
:p.Si desea libreras de compilacin y ejecucin 100 % compatibles&comma.  entonces Ud. debe definir&colon. HARBOUR&us.STRICT&us.CLIPPER&us.COMPATIBILITY.  Esta opcin debe ser definida en el archvivo
..&slash.include&slash.hbsetup.h  &lpar.en efecto esta opcin es puesta en un comentario por defecto &minus. Ud.  necesita remover los caracteres &slash.* *&slash. solamente. Este cambio debe ser  realizado antes de invocar la
utilidad make.
.br
.br
:p.Manejo de variables sin declarar
:p.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.
:p.Cuando un valor es asignado a una variable no declarada y la opcin  &minus.v  de la lnea de comandos no es usada&comma. entonces el compilador  Clipper asume que la variable es una variable PRIVATE  PUBLIC y  genera un opcode
POPM &lpar.pop memvar&rpar..
.br
:p.Cuando el valor de una variable no declarada es accedido y la opcin  &minus.v de la lnea de comandos no es usada&comma. el compilador Harbour genera  un opcode  PUSHV &lpar.push variable&rpar. para determinar el tipo de
variable  en tiempo de ejecucin
.br
:p.Si un campo con el nombre requerido existe en el area de trabajo  actual&comma. entonces este valor es usado. Si no existe el campo&comma. entones  una variable PRIVATE  PUBLIC es usada &lpar.si existe&rpar..
.br
:p.El compilador Harbour genera un opcode para determinar el tipo de  variable en tiempo de ejecucin &lpar.POPVARIABLE or PUSHVARIABLE&rpar. en  ambos casos &lpar.asignacin y acceso&rpar..
.br
:p.La diferencia puede ser chequeada por el siguiente cdigo&colon.
.br
      PROCEDURE MAIN&lpar.&rpar.
.br
      PRIVATE myname
.br

.br
        DBCREATE&lpar. &cdq.TEST&cdq.&comma. &lbrc. &lbrc. &cdq.MYNAME&cdq.&comma. &cdq.C&cdq.&comma. 10&comma. 0&rbrc. &rbrc. &rpar.
.br
        USE test NEW
.br
        SELECT test
.br
        APPEND BLANK
.br

.br
        FIELD&minus.>myname  &colon.&eq. &cdq.FIELD&cdq.
.br
        MEMVAR&minus.>myname &colon.&eq. &cdq.MEMVAR&cdq.
.br

.br
        myname &colon.&eq. myname + &cdq. assigned&cdq.
.br

.br
        &slash.&slash. In Clipper&colon. &cdq.FIELD&cdq.&comma.  In Harbour&colon. &cdq.FIELD assigned&cdq.
.br
        ? FIELD&minus.>myname
.br

.br
        &slash.&slash. In Clipper&colon. &cdq.MEMVAR assigned&cdq.&comma. In Harbour&colon. &cdq.MEMVAR&cdq.
.br
        ? MEMVAR&minus.>myname
.br

.br
        USE
.br

.br
      RETURN
.br
.br
:p.Pasando por refeerencia una variable no declarada
:p.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.
&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.
:p.El compilador Harbour usa un opcode especial PUSHP para pasar una  referencia  a una variable no declarada &lpar. el operador '@' &rpar.. El tipo  de la variable pasada es chequeada en tiempo de ejecucin &lpar.field or
memvar&rpar.. Sin embargo las variables de campo no pueden ser pasadas por  referencia. Esto significa que Clipper chequea slo la variable memvar  y no mira por una de campo.  Esta es la razn por la cual el compilador Harbour
usa el opcode  habitual PUSHMEMVARREF en estos casos. Ntese que el comportamiento  en tiempo de ejecucin es el mismo en Clipper y en Harbour &minus. slo los  opcodes generados son diferentes.
.br
.br
:p.Manejo de mensajes a objetos
:p.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.
.br
:p.El seteo de HARBOUR&us.STRICT&us.CLIPPER&us.COMPATIBILITY determina  la forma en que el envo encadenado de mensajes es manejado
.br
:p.Por ejemplo&comma. el siguiente cdigo&colon.
.br
:p.a&colon.b&lpar. COUNT&lpar.&rpar. &rpar.&colon.c +&eq. 1
.br
:p.ser manejado como&colon.
.br
:p.a&colon.b&lpar. COUNT&lpar.&rpar. &rpar.&colon.c &colon.&eq. a&colon.b&lpar. COUNT&lpar.&rpar. &rpar.&colon.c + 1
:p.en modo de compatibilidad estricta y
.br
:p.temp &colon.&eq. a&colon.b&lpar. COUNT&lpar.&rpar. &rpar.&comma. temp&colon.c +&eq. 1
:p.en modo no&minus.estricto.
.br
:p.En la prctica&comma. Clipper llamar a la funcin COUNT&lpar.&rpar. dos veces&colon.  La primera vez antes de la adicin y la segunda despus de la  adicin.  En Harbour&comma. COUNT&lpar.&rpar. ser llamada slo una vez&comma.
antes de la adicin.
.br
:p.El mtodo Harbour &lpar.no&minus.estricto&rpar. es&colon.
:p.1&rpar. Ms rpido
:p.2&rpar. Garantiza que la misma variable de instancia del mismo  objeto ser cambiada.
.br
:p.&lpar.Ver tambin&colon. ..&slash.source&slash.compiler&slash.expropt.c&rpar.
.br
.br
:p.Inicializacin variables estticas
:p.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.
&minus.&minus.
.br
:p.Hay una diferencia en la inicializacin de las variables estticas  que son inicializadas con un bloque de cdigo que refiere a una  variable local. Por ejemplo&colon.
.br
      PROCEDURE TEST&lpar.&rpar.
.br

.br
      LOCAL MyLocalVar
.br
      STATIC MyStaticVar &colon.&eq. &lbrc.&splitvbar.&splitvbar. MyLocalVar &rbrc.
.br

.br
        MyLocalVar &colon.&eq.0
.br
        ? EVAL&lpar. MyStaticVar &rpar.
.br

.br
      RETURN
.br
.br
:p.El cdigo de arriba compila bien en Clipper&comma. pero ste genera un  error de ejecucin&colon.  Error&slash.BASE 1132 Bound error&colon. array access
:p.Called from &lpar.b&rpar.STATICS&dollar.&lpar.0&rpar.
.br
:p.En Harbour este cdigo genera un error en tiempo de compilacin&colon.  Error E0009 Illegal variable &lpar.b&rpar. initializer&colon. 'MyLocalVar'
.br
:p.Ambos Clipper y Harbour estan manejando todas las variables locales  usadas en una forma especial&colon. ellas son separadas de la pila &lpar.stack&rpar.  local de la funcin &slash. procedimiento donde ellas son declaradas.
Esto permite acceder a estas variables despues de la salida de una  funcin &slash. procedimiento. Sin embargo todas las variables estticas
:p.son inicializadas en un procedimiento separado &lpar.'STATICS&dollar.' en Clipper  y '&lpar.&us.INITSTATICS&rpar.' en Harbour&rpar. antes del procedimiento principal y  antes de todos los procedimientos INIT. Las variables
locales no  existen en la pila de evaluacin &lpar.eval stack&rpar. donde las variables  estticas son inicializadas&comma. as ellas no pueden ser separadas.
.br
:h1 FECHY.FECHA
:h2  res=61.CDOW()
:i1 id=FECHAX.FECHA
:i2 refid=FECHAX.CDOW()
:p.CDOW&lpar.&rpar.
.br
.br
:hp2.Convierte una fecha al Nombre del da de la semana:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.CDOW&lpar.<dFecha>&rpar.  &minus.&minus.> cDia:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<dFecha>  Cualquier expresin de fecha.
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.<cDia>  El da actual de la semana.
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin devuelve una cadena de caracteres con el da de la semana  de una expresin de fecha <dFecha> pasada &lpar.DOW&eq.day of week en ingls&rpar..  Si una fecha NULL es pasada a la funcin&comma. el valor de la funcin
ser  un byte NULL.
.br
.br
:hp2.Examples:ehp2.
.br
:p.
:lm margin=6.
.br
      ? CDOW&lpar.DATE&lpar.&rpar.&rpar.
.br

.br
      IF CDOW&lpar. DATE&lpar.&rpar. + 10&rpar. &eq.&eq. &cdq.SUNDAY&cdq.
.br
         ? &cdq.Este es un da para el descanso.&cdq.
.br
      ENDIF
.br
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin es totalmente compatible con CA&minus.Clipper.
.br
.br
:hp2.Platforms:ehp2.
.br
:p.
:lm margin=6.
:p.Todas
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.La librera es rtl
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=62.DAY():elink.
.br
:link reftype=hd res=63.DOW():elink.
.br
:link reftype=hd res=64.DATE():elink.
.br
:link reftype=hd res=65.CMONTH():elink.
.br
:h2 id=FECHY res=65.CMONTH()
:i2 refid=FECHAX.CMONTH()
:p.CMONTH&lpar.&rpar.
.br
.br
:hp2.Retorna una cadena de caracteres con el nombre del mes:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.CMONTH&lpar.<dFecha>&rpar.  &minus.&minus.> cMes:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<dFecha>  Cualquier expresin de fecha.
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.<cMes>  el nombre actual del mes
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin retorna el nombre del mes &lpar.Enero&comma. Febrero&comma. etc.&rpar. de una  expresin de fecha <dFecha> pasada a ella.  Si una fecha NULL es pasada a la funcin&comma. el valor de la funcin sera  un byte NULL.
Nota&colon. El valor devuelto depende del mdulo de lenguaje en uso.
.br
.br
:hp2.Examples:ehp2.
.br
:p.
:lm margin=6.
.br
      ? CMONTH&lpar. DATE&lpar.&rpar.&rpar.          &slash.&slash. resultado&colon. Noviembre
.br

.br
      IF CMONTH&lpar. DATE&lpar.&rpar. + 35&rpar. &eq.&eq.&cdq.Diciembre&cdq.
.br
         ? &cdq.Ha hecho compras para las fiestas ?&cdq.
.br
      ENDIF
.br
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin es totalmente compatible con CA&minus.Clipper.
.br
.br
:hp2.Platforms:ehp2.
.br
:p.
:lm margin=6.
:p.Todas
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.La librera es rtl
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=61.CDOW():elink.
.br
:link reftype=hd res=64.DATE():elink.
.br
:link reftype=hd res=66.MONTH():elink.
.br
:link reftype=hd res=67.YEAR():elink.
.br
:link reftype=hd res=63.DOW():elink.
.br
:link reftype=hd res=68.DTOC():elink.
.br
:h2 id=FECHY res=64.DATE()
:i2 refid=FECHAX.DATE()
:p.DATE&lpar.&rpar.
.br
.br
:hp2.Retorna la fecha actual del sistema operativo:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.DATE&lpar.&rpar. &minus.&minus.> dFechaActual:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.Ninguno
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.<dFechaActual>&comma. la fecha actual del sistema.
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin devuelve la fecha actual del sistema.
.br
.br
:hp2.Examples:ehp2.
.br
:p.
:lm margin=6.
.br
      ? DATE&lpar.&rpar.
.br
.br
.br
:hp2.Tests:ehp2.
.br
:p.
:lm margin=6.
.br
      ? &cdq.Hoy es &cdq.&comma.DAY&lpar. DATE&lpar.&rpar.&rpar.&comma.&cdq. de &cdq.&comma.CMONTH&lpar. DATE&lpar.&rpar.&rpar.&comma.&cdq. de &cdq.&comma.YEAR&lpar. DATE&lpar.&rpar.&rpar.
.br
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin es totalmente compatible con CA&minus.Clipper.
.br
.br
:hp2.Platforms:ehp2.
.br
:p.
:lm margin=6.
:p.Todas
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.La librera es rtl
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=69.CTOD():elink.
.br
:link reftype=hd res=70.DTOS():elink.
.br
:link reftype=hd res=68.DTOC():elink.
.br
:link reftype=hd res=62.DAY():elink.
.br
:link reftype=hd res=66.MONTH():elink.
.br
:link reftype=hd res=65.CMONTH():elink.
.br
:h2 id=FECHY res=69.CTOD()
:i2 refid=FECHAX.CTOD()
:p.CTOD&lpar.&rpar.
.br
.br
:hp2.Convierte una cadena de caracteres a una expresin de fecha:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.CTOD&lpar.<cCadenaFecha>&rpar.  &minus.&minus.> dFecha:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<cCadenaFecha> Un fecha en el formato 'mm&slash.dd&slash.yy'
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.<dFecha> Una expresin de fecha.
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin convierte una fecha que ha sido aportada como una  expresin de caracteres a una expresin de fecha. La expresin de  caracteres sera en la forma MM&slash.DD&slash.YY&cdq. &lpar.basada en el valor por defecto  en SET
DATE&rpar. o en el formato apropiado especificado por el comado  SET DATE TO. Si una impropia cadena de caracteres es pasada a la  funcin&comma. un valor de fecha vaca ser retornado.
.br
.br
:hp2.Examples:ehp2.
.br
:p.
:lm margin=6.
.br
      ? CTOD&lpar.'12&slash.21&slash.00'&rpar.
.br
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin es totalmente compatible con CA&minus.Clipper.
.br
.br
:hp2.Platforms:ehp2.
.br
:p.
:lm margin=6.
:p.Todas
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.La librera es rtl
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=71.SET DATE:elink.
.br
:link reftype=hd res=64.DATE():elink.
.br
:link reftype=hd res=70.DTOS():elink.
.br
:h2 id=FECHY res=62.DAY()
:i2 refid=FECHAX.DAY()
:p.DAY&lpar.&rpar.
.br
.br
:hp2.Retorna el nmero de da del mes en el rango de 0 a 31:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.DAY&lpar.<cFecha>&rpar. &minus.&minus.> nMes:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<cFecha> Cualquier expresin vlida de fecha.
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.Retorna <nMes>&comma. el valor numrico del da del mes.
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin retorna el valor numrico del da del mes de una fecha.
.br
.br
:hp2.Examples:ehp2.
.br
:p.
:lm margin=6.
.br
      ? DAY&lpar. CTOD&lpar.&cdq.06&slash.06&slash.1944&cdq.&rpar. &rpar.     &slash.&slash. Resultado&colon. 6
.br
      ? DAY&lpar. DATE&lpar.&rpar. + 6325&rpar.
.br
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin es totalmente compatible con CA&minus.Clipper.
.br
.br
:hp2.Platforms:ehp2.
.br
:p.
:lm margin=6.
:p.Todas
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.La librera es rtl
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=69.CTOD():elink.
.br
:link reftype=hd res=70.DTOS():elink.
.br
:link reftype=hd res=68.DTOC():elink.
.br
:link reftype=hd res=64.DATE():elink.
.br
:link reftype=hd res=66.MONTH():elink.
.br
:link reftype=hd res=65.CMONTH():elink.
.br
:h2 id=FECHY res=72.DAYS()
:i2 refid=FECHAX.DAYS()
:p.DAYS&lpar.&rpar.
.br
.br
:hp2.Convierte los segundos transcurridos a das.:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.DAYS&lpar.<nSegundos> &rpar. &minus.&minus.> nDia:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<nSegundos> el nmero de segundos.
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.Retorna el nmero de das transcurridos
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin convierte <nSegundos> al nmero equivalente de das&semi.  86399 segundos representan un da&comma. cero segundos es medianoche.
.br
.br
:hp2.Examples:ehp2.
.br
:p.
:lm margin=6.
.br
      ? DAYS&lpar. 2434234&rpar.
.br
      ? &cdq.Han transcurrido &cdq.&comma. DAYS&lpar.63251&rpar.
.br
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin es totalmente compatible con CA&minus.Clipper.  Nota&colon. No esta documentada en las NG&comma. ni en el manual en espaol de  CA&minus.Clipper
.br
.br
:hp2.Platforms:ehp2.
.br
:p.
:lm margin=6.
:p.Todas
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.La librera es rtl
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=73.SECONDS():elink.
.br
:link reftype=hd res=74.SECS():elink.
.br
:link reftype=hd res=75.ELAPTIME():elink.
.br
:h2 id=FECHY res=63.DOW()
:i2 refid=FECHAX.DOW()
:p.DOW&lpar.&rpar.
.br
.br
:hp2.Convierte una fecha al nmero del dia de la semana &lpar.1&minus.7&rpar.:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.DOW&lpar.<dFecha>&rpar. &minus.&minus.> nDia:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<dFecha>  Cualquier expresin vlida de fecha.
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.DOW&lpar.&rpar. retorna el dia de la semana en la forma numrica <nDay>
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin convierte un valor de fecha en un nmero representando  el dia de la semana. En el rango de 1 al 7&comma. siendo 1 el dia Domingo  y 7 el dia Sbado.
.br
.br
:hp2.Examples:ehp2.
.br
:p.
:lm margin=6.
.br
      ? DOW&lpar. DATE&lpar.&rpar.&rpar.
.br
      ? DOW&lpar. DATE&lpar.&rpar. &minus. 6584&rpar.
.br
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin es totalmente compatible con CA&minus.Clipper.
.br
.br
:hp2.Platforms:ehp2.
.br
:p.
:lm margin=6.
:p.Todas
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.La librera es rtl
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=68.DTOC():elink.
.br
:link reftype=hd res=61.CDOW():elink.
.br
:link reftype=hd res=64.DATE():elink.
.br
:link reftype=hd res=70.DTOS():elink.
.br
:link reftype=hd res=62.DAY():elink.
.br
:h2 id=FECHY res=68.DTOC()
:i2 refid=FECHAX.DTOC()
:p.DTOC&lpar.&rpar.
.br
.br
:hp2.Convierte un valor de fecha a una cadena de caracteres:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.DTOC&lpar.<dFecha>&rpar.  &minus.&minus.> cFecha:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<dFechaString> Cualquier expresin vlida de fecha.
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.Retorna la cadena de caracteres <cFecha> representando la fecha
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin convierte una expresin de fecha &lpar.sea un campo  una  variable&rpar. expresada como <dFecha> a una expresin de caracteres en el  formato por defecto &cdq.MM&slash.DD&slash.YY&cdq.. El formato de fecha devuelto
por esta  funcin es controlado por el formato especificado por el comando  SET DATE y es variable a diferencia del devuelto por la funcin DTOS&lpar.&rpar..
.br
.br
:hp2.Examples:ehp2.
.br
:p.
:lm margin=6.
.br
      ? DTOC&lpar. DATE&lpar.&rpar.&rpar.
.br
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin es totalmente compatible con CA&minus.Clipper.
.br
.br
:hp2.Platforms:ehp2.
.br
:p.
:lm margin=6.
:p.Todas
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.La librera es rtl
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=71.SET DATE:elink.
.br
:link reftype=hd res=64.DATE():elink.
.br
:link reftype=hd res=70.DTOS():elink.
.br
:h2 id=FECHY res=70.DTOS()
:i2 refid=FECHAX.DTOS()
:p.DTOS&lpar.&rpar.
.br
.br
:hp2.Convierte un valor de fecha a una cadena en el formato AAAAMMDD:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.DTOS&lpar.<dFecha>&rpar.  &minus.&minus.> cFecha:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<dFecha> Cualquier expresin vlida de fecha.
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.DTOS&lpar.&rpar. retorna <cFecha>
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin convierte un valor de fecha a una cadena de 8 caracteres  en el formato AAAAMMDD &lpar.no contiene separadores&rpar.. Si el valor de  <dFecha> es una fecha vaca&comma. esta funcin retorna una cadena de  caracteres
de 8 espacios en blanco.
.br
.br
:hp2.Examples:ehp2.
.br
:p.
:lm margin=6.
.br
      ? DTOS&lpar. DATE&lpar.&rpar.&rpar.
.br
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin es totalmente compatible con CA&minus.Clipper.
.br
.br
:hp2.Platforms:ehp2.
.br
:p.
:lm margin=6.
:p.Todas
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.La librera es rtl
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=68.DTOC():elink.
.br
:link reftype=hd res=64.DATE():elink.
.br
:link reftype=hd res=70.DTOS():elink.
.br
:h1 HORAY.HORA
:h2  res=75.ELAPTIME()
:i1 id=HORAX.HORA
:i2 refid=HORAX.ELAPTIME()
:p.ELAPTIME&lpar.&rpar.
.br
.br
:hp2.Calcula el tiempo transcurrido.:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.ELAPTIME&lpar.<cHoraInicial>&comma.<cHoraFinal>&rpar. &minus.&minus.> cTranscurrido:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<cHoraInicial> Hora de inicio en el formato de cadena HH&colon.MM&colon.SS  <cHoraFinal>   Hora de finalizacin en el formato de cadena HH&colon.MM&colon.SS
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.<cTranscurrido>  Diferencia entre tiempos
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin devuelve una cadena que muestra la diferencia entre la  hora inicial representada por <cHoraInicial> y la hora final  representada por <cHoraFinal>. Si la hora de inicio es mayor que la  de finalizacin&comma. la
funcin asume que la fecha a cambiado una vez.
.br
.br
:hp2.Examples:ehp2.
.br
:p.
:lm margin=6.
.br
      &slash.&slash. Muestra el tiempo que se uso el programa parecido a como lo
.br
      &slash.&slash. haca el viejo Norton Utilities
.br
      STATIC cHoraIni       &slash.&slash. al inicio del programa
.br
      cHoraIni &colon.&eq. TIME&lpar.&rpar.
.br

.br
      &slash.&slash. A la salida del programa
.br
      ? &cdq.Ud. ha usado el programa durante&colon. &cdq.&comma. ELAPTIME&lpar. cHoraIni&comma. TIME&lpar.&rpar.&rpar.
.br
      QUIT
.br
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin es totalmente compatible con CA&minus.Clipper.
.br
.br
:hp2.Platforms:ehp2.
.br
:p.
:lm margin=6.
:p.Todas
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.La librera es rtl
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=74.SECS():elink.
.br
:link reftype=hd res=73.SECONDS():elink.
.br
:link reftype=hd res=76.TIME():elink.
.br
:link reftype=hd res=62.DAY():elink.
.br
:h2 id=FECHY res=66.MONTH()
:i2 refid=FECHAX.MONTH()
:p.MONTH&lpar.&rpar.
.br
.br
:hp2.Extrae el mes como valor numrico de un valor de fecha dado:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.MONTH&lpar.<dFecha>&rpar. &minus.&minus.> nMes:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<dFecha> Cualquier expresin vlida de fecha.
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.MONTH&lpar.&rpar. retorna <nMes>&comma. nmero correspondiente al mes del ao&comma. en el  rango de 0 a 12.
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin devuelve el valor numrico del mes contenido en <dFecha>.  Este valor esta en el formato de cuatro dgitos y no es afectado  por el seteo de los comandos SET CENTURY y SET DATE.  Si se pasa una fecha vaca
CTOD&lpar.&cdq.&cdq.&rpar. a esta funcin devuelve el valor  cero.
.br
.br
:hp2.Examples:ehp2.
.br
:p.
:lm margin=6.
.br
      ? Month&lpar.DATE&lpar.&rpar.&rpar.
.br
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin es totalmente compatible con CA&minus.Clipper.
.br
.br
:hp2.Platforms:ehp2.
.br
:p.
:lm margin=6.
:p.Todas
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.La librera es rtl
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=61.CDOW():elink.
.br
:link reftype=hd res=63.DOW():elink.
.br
:link reftype=hd res=67.YEAR():elink.
.br
:link reftype=hd res=65.CMONTH():elink.
.br
:h2 id=HORAY res=73.SECONDS()
:i2 refid=HORAX.SECONDS()
:p.SECONDS&lpar.&rpar.
.br
.br
:hp2.Retorna el nmero de segundos transcurridos desde medianoche.:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.SECONDS&lpar.&rpar. &minus.&minus.> nSegundos:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.Ninguno
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.SECONDS&lpar.&rpar. retorna <nSegundos> desde la medianoche.
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin devuelve un valor numrico representando el nmero de  segundos transcurridos desde la medianoche del da actual&comma. basado en  la hora actual del sistema operativo.  SECONDS&lpar.&rpar. se inicializa en cero
&lpar.medianoche&rpar. y continua hasta 86399  segundos &lpar.23&colon.59&colon.59&rpar.. El valor que devuelve es expresado como segundos  y centsimas de segundo.
.br
.br
:hp2.Examples:ehp2.
.br
:p.
:lm margin=6.
.br
      &slash.&slash. Muestra el tiempo que estuvo en ejecucin una rutina
.br
      nArranque &eq. SECONDS&lpar.&rpar.
.br

.br
      &slash.&slash. Aca va la llamada a la rutina
.br
      &slash.&slash.  &colon. &colon.
.br
      ? &cdq.Tard&colon. &cdq.&comma. SECONDS&lpar.&rpar.&minus. nArranque  &comma.&cdq. segundos&cdq.
.br
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin es totalmente compatible con CA&minus.Clipper.
.br
.br
:hp2.Platforms:ehp2.
.br
:p.
:lm margin=6.
:p.Todas
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.La librera es rtl
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=76.TIME():elink.
.br
:h2 id=HORAY res=74.SECS()
:i2 refid=HORAX.SECS()
:p.SECS&lpar.&rpar.
.br
.br
:hp2.Retorna el nmero de segundos de la hora del sistema.:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.SECS&lpar. <cHora> &rpar. &minus.&minus.> nSegundos:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<cHora> Expresin de caracteres en el formato de tiempo HH&colon.MM&colon.SS
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.SECS&lpar.&rpar. retorna <nsegundos> Numbero de segundos
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin devuelve un valor numrico que es el nmero de segundos  transcurridos desde medianoche&comma. basados en una cadena de hora dado  como <cHora>.
.br
.br
:hp2.Examples:ehp2.
.br
:p.
:lm margin=6.
.br
      ? SECS&lpar. TIME&lpar.&rpar.&rpar.
.br
      ? SECS&lpar. TIME&lpar.&rpar. &minus. 10&rpar.
.br
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin es totalmente compatible con CA&minus.Clipper.  Nota&colon. No esta documentada en las NG&comma. ni en el manual en espaol de  CA&minus.Clipper.
.br
.br
:hp2.Platforms:ehp2.
.br
:p.
:lm margin=6.
:p.Todas
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.La librera es rtl
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=73.SECONDS():elink.
.br
:link reftype=hd res=75.ELAPTIME():elink.
.br
:link reftype=hd res=76.TIME():elink.
.br
:h2 id=HORAY res=76.TIME()
:i2 refid=HORAX.TIME()
:p.TIME&lpar.&rpar.
.br
.br
:hp2.Retorna la hora del sistema como una cadena de caracteres:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.TIME&lpar.&rpar. &minus.&minus.> cHora:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.Ninguno
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.TIME&lpar.&rpar. retorna la cadena de caracteres <cHora> representando la hora
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin devuelve la hora del sistema representada como una  expresin de caracteres en el formato HH&colon.MM&colon.SS&comma. para calculos de  tiempo conviene usar SECONDS&lpar.&rpar..
.br
.br
:hp2.Examples:ehp2.
.br
:p.
:lm margin=6.
.br
      ? TIME&lpar.&rpar.   &slash.&slash. Resultado&colon. 21&colon.34&colon.12
.br
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin es totalmente compatible con CA&minus.Clipper.
.br
.br
:hp2.Platforms:ehp2.
.br
:p.
:lm margin=6.
:p.Todas
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.La librera es rtl
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=64.DATE():elink.
.br
:link reftype=hd res=73.SECONDS():elink.
.br
:h2 id=FECHY res=67.YEAR()
:i2 refid=FECHAX.YEAR()
:p.YEAR&lpar.&rpar.
.br
.br
:hp2.Extrae el ao como valor numrico de un valor de fecha dado:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.YEAR&lpar.<dFecha>&rpar. &minus.&minus.> nAno:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<dFecha> Cualquier expresin vlida de fecha.
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.YEAR&lpar.&rpar. retorna <nAno> la porcin de ao de una fecha.
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin devuelve el valor numrico del ao contenido en <dFecha>  Este valor esta en el formato de cuatro dgitos y no es afectado  por el seteo de los comandos SET CENTURY y SET DATE.  Si se pasa una fecha vaca
CTOD&lpar.&cdq.&cdq.&rpar. a esta funcin devuelve el valor  cero.
.br
.br
:hp2.Examples:ehp2.
.br
:p.
:lm margin=6.
.br
      ? YEAR&lpar. DATE&lpar.&rpar.&rpar.                &slash.&slash. Resultado&colon. 2000
.br
      ? YEAR&lpar. CTOD&lpar.&cdq.01&slash.31&slash.1982&cdq.&rpar.&rpar.    &slash.&slash. Resultado&colon. 1982
.br
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin es totalmente compatible con CA&minus.Clipper.
.br
.br
:hp2.Platforms:ehp2.
.br
:p.
:lm margin=6.
:p.Todas
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.La librera es rtl
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=62.DAY():elink.
.br
:link reftype=hd res=66.MONTH():elink.
.br
:h2 id=COMAY res=77.DIR
:i2 refid=COMANX.DIR
:p.DIR
.br
.br
:hp2.Muestra el listado de archivos:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.DIR &lbrk.<cFileMask>&rbrk..:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<cFileMask> Mscara de archivos para incluir en el retorno de la  funcin. Esta podra contener subdirectorios &lpar.path&rpar. y caracteres  estndar usados como comdines&comma. segun sean soportados por el sistema  operativo
&lpar.como * y ?&rpar.. Si <cFileMask> no contiene la ruta al archivo  entonces SET DEFAULT es usado para mostrar archivos en la mscara.
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.Si ninguna <cFileMask> es dada&comma. &us.&us.Dir&lpar.&rpar. muestra informacin acerca de  todos los *.DBF en la ruta SET DEFAULT. esta informacin contiene&colon.  &minus. Nombre del archivo  &minus. Nmero de registros
&minus. Fecha de la ultima actualizacin  &minus. Tamao de cada archivo.
.br
:p.Si <cFileMask> es dada&comma. &us.&us.Dir&lpar.&rpar. lista todos los archivos que coinciden  con la mscara en los siguientes detalles&colon. Nombre&comma. Extensin&comma. Tamao&comma.  Fecha.
.br
:p.El comando DIR es pre&minus.procesado en la funcin &us.&us.Dir&lpar.&rpar. durante el  tiempo de compilacin.
.br
:p.&us.&us.Dir&lpar.&rpar. es una funcin de compatibilidad&comma. esta fu superada por  DIRECTORY&lpar.&rpar.&comma. la cual devuelve toda la informacin en un arreglo  multidimensional.
.br
.br
:hp2.Examples:ehp2.
.br
:p.
:lm margin=6.
.br
      &us.&us.Dir&lpar.&rpar.   &slash.&slash. Informacin de todos los DBF en el directorio actual
.br

.br
      &us.&us.Dir&lpar. &cdq.*.dbf&cdq. &rpar.       &slash.&slash. Lista todos los DBF en el directorio actual
.br

.br
      &slash.&slash. Lista todos los PRG de la librera de ejecucin &lpar.RTL&rpar. de Harbour
.br
      &slash.&slash. para sistemas operativos compatibles con DOS
.br
      &us.&us.Dir&lpar. &cdq.c&colon.\harbour\source\rtl\*.prg&cdq. &rpar.
.br

.br
      &slash.&slash. Lista todos los archivos de la seccin pblica sobre una mquina
.br
      &slash.&slash. tipo Unix
.br
      &us.&us.Dir&lpar. &cdq.&slash.pub&cdq. &rpar.
.br
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.Informacin de DBF&colon. CA&minus.Clipper muestra nombres de archivos en el  formato 8.3&comma. Harbour muestra los primeros 15 caracteres si un nombre  largo de archivo est disponible.
.br
:p.Listado de archivos&colon. para formatear los nombres mostrados usamos algo  as como&colon.  PADR&lpar. Nombre&comma. 8 &rpar. + &cdq. &cdq. + PADR&lpar. Ext&comma. 3 &rpar.  CA&minus.Clipper usa nombres de archivo 8.3&comma.
con Harbour probablemente se  podra cortar los nombres largos de archivo para llenar este molde.
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=78.ADIR():elink.
.br
:link reftype=hd res=79.DIRECTORY():elink.
.br
:link reftype=hd res=80.SET DEFAULT:elink.
.br
:link reftype=hd res=81.__DIR()*:elink.
.br
:h2 id=ARRAY res=78.ADIR()
:i2 refid=ARRAYX.ADIR()
:p.ADIR&lpar.&rpar.
.br
.br
:hp2.Llena arrays pre&minus.definidos con informacin de archivo &slash. directorio:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.ADIR&lpar. &lbrk.<cFileMask>&rbrk..&comma. &lbrk.<aNombre>&rbrk..&comma. &lbrk.<aTamano>&rbrk..&comma. &lbrk.<aFecha>&rbrk..&comma.:ehp2.
:p.:hp2.&lbrk.<aHora>&rbrk..&comma. &lbrk.<aAtrib>&rbrk.. &rpar. &minus.> nEntradasDirectorio:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<cFileMask> Mscara de archivos para incluir en el retorno de la  funcin. Esta podria contener subdirectorios &lpar.path&rpar. y caracteres  estandar usados como comodines&comma. segun sean soportados por el sistema  operativo
&lpar.como * y ?&rpar.. Si <cFileMask> no contiene la ruta al archivo  entonces SET DEFAULT es usado para mostrar archivos en la mscara.
.br
:p.<aNombre> Array para llenar con el Nombre de los archivos que cumplen  con <cFileMask>. Cada elemento es una cadena de caracteres que incluye  el Nombre y Extensin del archivo sin la ruta de acceso.  Nombre es el nombre largo de
archivo como es reportado por el sistema  operativo y no necesariamente en el formato maysculas 8.3 del D.O.S.
.br
:p.<aTamano> Array  para llenar con el Tamao de los archivos que cumplen  con <cFileMask>. Cada elemento es un nmero entero con el tamao del  archivo en bytes.  Los Directorios siempre tienen un tamao cero.
.br
:p.<aFecha> Array para llenar con la Fecha de la ultima modificacin del  archivo que cumplen con <cFileMask>. Cada elemento es del tipo &cdq.Date&cdq.
.br
:p.<aHora> Array para llenar con la Hora de la ultima modificacin del  archivo que cumplen con <cFileMask>. Cada elemento es una cadena de  caracteres en el formato&colon.      HH&colon.MM&colon.SS.
.br
:p.<aAtrib> Array para llenar con los atributos de los archivos que  cumplen con <cFileMask>. Cada elemento es una cadena de caracteres&comma.  Vea DIRECTORY&lpar.&rpar. por informacin sobre los valores de los atributos.  Si Ud.
pasa un array a <aAtrib>&comma. la funcin va a devolver archivos  con los atributos Normal&comma. Oculto &lpar.H&rpar.&comma. sistema &lpar.S&rpar. y directorio &lpar.D&rpar.  Si <aAtrib> no es especificado o es distinto de un
array solo  archivos con atributo normal porian ser devueltos.
.br
:p.Nota&colon. Al momento de escribir esta documentacin todavia no haba  informacin sobre el comportamiento de esta funcin con los  atributos que poseen las maquinas tipo Unix.
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.ADIR&lpar.&rpar. retorna el nmero de entradas de archivo que cumplen con la  condicin establecida en la mscara <cFileMask>.
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.ADIR&lpar.&rpar. retorna el nmero de archivos y&slash.o directorios que cumplen con  un formato especificado&comma. este tambien llena una serie de arrays con  Nombre&comma. Tamao&comma. Fecha&comma. Hora y Atributo de estos
archivos.  El array pasado debe ser pre&minus.inicializado al tamao apropiado&comma. vea el  ejemplo ms abajo.  Con motivo de incluir los atributos Oculto &lpar.H&rpar.&comma. sistema &lpar.S&rpar. o de  directorio
&lpar.D&rpar. <aAtrib> debe ser especificado.
.br
:p.ADIR&lpar.&rpar. es una funcin de compatibilidad&comma. esta fue superada por  DIRECTORY&lpar.&rpar.&comma. la cual devuelve toda la informacin en un arreglo  multidimensional.
.br
.br
:hp2.Examples:ehp2.
.br
:p.
:lm margin=6.
.br
      LOCAL aNombre&comma. aTamano&comma. aFecha&comma. aHora&comma. aAtrib&comma. nLen&comma. i
.br
      nLen &colon.&eq. ADIR&lpar. &cdq.*.JPG&cdq. &rpar.   &slash.&slash. Nro de archivos JPG files en directorio
.br

.br
      IF nLen > 0
.br
         aNombre &colon.&eq. Array&lpar. nLen &rpar.  &slash.&slash. hace lugar para guardar la informacin
.br
         aTamano &colon.&eq. Array&lpar. nLen &rpar.
.br
         aFecha &colon.&eq. Array&lpar. nLen &rpar.
.br
         aHora &colon.&eq. Array&lpar. nLen &rpar.
.br
         aAtrib &colon.&eq. Array&lpar. nLen &rpar.
.br
         FOR i &eq. 1 TO nLen
.br
             ? aNombre&lbrk.i&rbrk..&comma. aTamano&lbrk.i&rbrk..&comma. aFecha&lbrk.i&rbrk..&comma. aHora&lbrk.i&rbrk..&comma. aAtrib&lbrk.i&rbrk..
.br
         NEXT
.br
      ELSE
.br
         ? &cdq.Este directorio no tiene ni pelusa&cdq.
.br
      ENDIF
.br
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.<aNombre> esta yendo a ser llenado con nombres largos de archivo y  no necesariamente con el formato maysculas 8.3 del D.O.S.
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.La librera es rtl
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=1.ARRAY():elink.
.br
:link reftype=hd res=79.DIRECTORY():elink.
.br
:link reftype=hd res=80.SET DEFAULT:elink.
.br
:h1 MANEY.MANEJO DE ARCHIVOS
:h2  res=81.__Dir()*
:i1 id=MANEJX.MANEJO DE ARCHIVOS
:i2 refid=MANEJX.__DIR()*
:p.&us.&us.Dir&lpar.&rpar.*
.br
.br
:hp2.Muestra por pantalla el listado de archivos.:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.&us.&us.Dir&lpar. &lbrk.<cFileMask>&rbrk.. &rpar. &minus.&minus.> NIL:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<cFileMask> Mscara de archivos para incluir en el retorno de la  funcin. Esta podra contener subdirectorios &lpar.path&rpar. y caracteres  estndar usados como comdines&comma. segun sean soportados por el sistema  operativo
&lpar.como * y ?&rpar.. Si <cFileMask> no contiene la ruta al archivo  entonces SET DEFAULT es usado para mostrar archivos en la mscara.
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.&us.&us.Dir&lpar.&rpar. siempre retorna NIL.
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.Si ninguna <cFileMask> es dada&comma. &us.&us.Dir&lpar.&rpar. muestra informacin acerca de  todos los *.DBF en la ruta SET DEFAULT. Esta informacin contiene&colon.  &minus. Nombre del archivo  &minus. Numero de registros
&minus. Fecha de la ultima actualizacin  &minus. Tamao de cada archivo.
.br
:p.Si <cFileMask> es dada&comma. &us.&us.Dir&lpar.&rpar. lista todos los archivos que coinciden  con la mscara en los siguientes detalles&colon. Nombre&comma. Extensin&comma. Tamao&comma.  Fecha.
.br
:p.El comando DIR es pre&minus.procesado en la funcin &us.&us.Dir&lpar.&rpar. durante el  tiempo de compilacin.
.br
:p.&us.&us.Dir&lpar.&rpar. es una funcin de compatibilidad&comma. esta fu superada por  DIRECTORY&lpar.&rpar.&comma. la cual devuelve toda la informacin en un arreglo  multidimensional.
.br
.br
:hp2.Examples:ehp2.
.br
:p.
:lm margin=6.
.br
      &us.&us.Dir&lpar.&rpar.   &slash.&slash. Informacin de todos los DBF en el directorio actual
.br

.br
      &us.&us.Dir&lpar. &cdq.*.dbf&cdq. &rpar.       &slash.&slash. Lista todos los DBF en el directorio actual
.br

.br
      &slash.&slash. Lista todos los PRG de la librera de ejecucin &lpar.RTL&rpar. de Harbour
.br
      &slash.&slash. para sistemas operativos compatibles con DOS
.br
      &us.&us.Dir&lpar. &cdq.c&colon.\harbour\source\rtl\*.prg&cdq. &rpar.
.br

.br
      &slash.&slash. Lista todos los archivos de la seccin pblica sobre una mquina
.br
      &slash.&slash. tipo Unix
.br
      &us.&us.Dir&lpar. &cdq.&slash.pub&cdq. &rpar.
.br
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.Informacin de DBF&colon. CA&minus.Clipper muestra nombres de archivos en el  formato 8.3&comma. Harbour muestra los primeros 15 caracteres si un nombre  largo de archivo esta disponible.
.br
:p.Listado de archivos&colon. para formatear los nombres mostrados usamos algo  as como&colon.  PADR&lpar. Nombre&comma. 8 &rpar. + &cdq. &cdq. + PADR&lpar. Ext&comma. 3 &rpar.  CA&minus.Clipper usa nombres de archivo 8.3&comma.
con Harbour probablemente se  podra cortar los nombres largos de archivo para llenar este molde.
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.La librera es rtl
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=78.ADIR():elink.
.br
:link reftype=hd res=79.DIRECTORY():elink.
.br
:link reftype=hd res=80.SET DEFAULT:elink.
.br
:link reftype=hd res=77.DIR:elink.
.br
:h1 BAJOY.BAJO NIVEL
:h2  res=82.DISKSPACE()
:i1 id=BAJOX.BAJO NIVEL
:i2 refid=BAJOX.DISKSPACE()
:p.DISKSPACE&lpar.&rpar.
.br
.br
:hp2.Obtiene la cantidad de espacio disponible en el disco:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.DISKSPACE&lpar. &lbrk.<nDisco>&rbrk.. &lbrk.&comma. <nTipo>&rbrk.. &rpar. &minus.&minus.> nDiskbytes:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<nDrive> es el nmero de disco del que esta solicitando informacin  donde 1 &eq. A&comma. 2 &eq. B&comma. etc&comma. Si se especifica cero  ningn  parametro DISKPACE&lpar.&rpar. trabaja sobre la unidad actual de disco  Por
defecto es cero.
.br
:p.<nTipo> es el tipo de espacio que est siendo requerido.  Por defecto  es HB&us.DISK&us.AVAIL.
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.<nDiskBytes> es el nmero de bytes en la unidad especificada que  coincide con el tipo requerido.
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.Por defecto esta funcin retorna el nmero de bytes de espacio libre  en el disco actual que esta disponible para el usuario que solicita  la informacin.
.br
:p.Hay 4 tipos de informacin disponible&colon.
.br
:p.HB&us.FS&us.AVAIL   La cantidad de espacio disponible para el usuario que  hace la solicitud. Este valor podra ser menor que  HB&us.FS&us.FREE si las asignaciones de espacio en disco  &lpar.quotas&rpar. son soportadas por el
sistema operativo al  tiempo de ejecucin y estas quotas estn asignadas.  De otro modo el valor ser igual al retornado por  HB&us.FS&us.FREE.
.br
:p.HB&us.FS&us.FREE    La cantidad actual de espacio libre en el disco.
.br
:p.HB&us.FS&us.USED    El nmero de bytes en uso en el en el disco.
.br
:p.HB&us.FS&us.TOTAL   La cantidad total de espacio asignado para el usuario  si las quotas estan asignadas. De otro modo el tamao  actual del disco.
.br
:p.Si la informacin es requerida sobre un disco que no esta disponible  un error de ejecucin 2018 ser establecido.
.br
.br
:hp2.Examples:ehp2.
.br
:p.
:lm margin=6.
.br
      ? &cdq.Ud. tiene diponible&colon. &cdq. + STR&lpar. DISKSPACE&lpar.&rpar. &rpar. + &cdq. bytes &cdq. +&semi.
.br
        &cdq.sobre un total de &cdq. + STR&lpar. DISKSPACE&lpar. 0&comma. HB&us.FS&us.TOTAL&rpar. &rpar.
.br

.br
      Note&colon. Ver ..\tests\tstdspac.prg por otros ejemplos.
.br
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Started
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.CA&minus.Clipper retorna un valor entero cuya utilidad esta limitada a  discos menores de 2 gigabytes. La versin de Harbour retorna un valor  de punto flotante con 0 decimales si el disco es > 2 gigabytes.  <nTipo> es una
extensin de Harbour.
.br
.br
:hp2.Platforms:ehp2.
.br
:p.
:lm margin=6.
:p.Dos&comma. Win32&comma. OS&slash.2&comma. Unix
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.El cdigo fuente est en diskspac.c  La librera asociada es rtl  El archivo de cabecera es fileio.ch
:h1 RECUY.RECUPERACION DE ERRORES
:h2  res=83.ERRORSYS()
:i1 id=RECUPX.RECUPERACION DE ERRORES
:i2 refid=RECUPX.ERRORSYS()
:p.ERRORSYS&lpar.&rpar.
.br
.br
:hp2.Instala el manejador de errores por defecto:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.ERRORSYS&lpar.&rpar. &minus.&minus.> NIL:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.Ninguno.
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.ERRORSYS&lpar.&rpar. siempre retorna NIL.
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.ERRORSYS&lpar.&rpar. es llamado en el inicio por Harbour e instala el manejador  de errores por defecto. Normalmente no se debe llamar a esta funcin  directamente. En su lugar use ERRORBLOCK&lpar.&rpar. para instalar su propio
manejador de errores.
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin es 100 % Clipper compatible
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.El cdigo fuente est en errorsys.c  La librera asociada es rtl
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=84.ERRORBLOCK():elink.
.br
:link reftype=hd res=85.ERROR CLASS:elink.
.br
:h1 BLOQY.BLOQUE DE CDIGO
:h2  res=21.EVAL()
:i1 id=BLOQUX.BLOQUE DE CDIGO
:i2 refid=BLOQUX.EVAL()
:p.EVAL&lpar.&rpar.
.br
.br
:hp2.Evala un bloque de cdigo &lpar.codeblock&rpar.:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.EVAL&lpar. <bBloque> &lbrk.&comma. <xVal> &lbrk.&comma....&rbrk..&rbrk..&rpar.   &minus.&minus.> xExpresion:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<bBloque>  Bloque de cdigo a ser evaluado.
.br
:p.<xVal>     Argumento para ser pasado al bloque de cdigo.
.br
:p.<xVal...>  Lista de argumentos para ser pasados al bloque de cdigo.
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.EVAL&lpar.&rpar. retorna <xExpresion>&comma. el valor de la ltima expresin dentro  del bloque. El valor devuelto puede ser de cualquier tipo vlido.
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin evala el bloque de cdigo expresado como <bBloque> al  ejecutarlo y pasarle los parmetros como argumentos &comma.luego retorna su  valor evaluado. Si hay mltiples expresiones dentro del bloque de  cdigo&comma. la
ltima expresin ser el valor de esta funcin.
.br
:p.Si el bloque de cdigo requiere parmetros para ser pasados a ste&comma.  ellos son especificados en la lista de parmetros <xVal>.  Cada parmetro es separado por una coma dentro de la lista de  parmetros y cada expresin es
separada por comas dentro de la lista  de expresiones.
.br
:p.Nota&colon. Un bloque de cdigo es un valor de datos especial que hace  referencia a cdigo de programa compilado &lpar.contiene cdigo  ejecutable&rpar.&comma. puede incluso contener funciones y el hecho que  permite exportar
variables estticas y locales dentro de l&comma.  la da una gran versatilidad.  Aunque las macros y los bloques de cdigo son similares&comma. las  Las macros son cadenas de caracteres que se compilan durante  la ejecucin de un
programa y se ejecutan a continuacin.  Los bloques de cdigo se compilan junto con los otros PRG  durante la compilacin del programa. Por esto son ms rpidos&comma.  Es posible compilar un bloque de cdigo en tiempo de
ejecucin  desde una cadena de caracteres usando el operador de macros &lpar.&amp.&rpar..  Un bloque de cdigo esta compuesto por&colon.  &lbrc. &splitvbar.<lista argumentos>&splitvbar. <lista expresiones> &rbrc.  Los separadores
verticales deben estar presentes aunque no el  bloque no reciba argumentos.
.br
.br
:hp2.Examples:ehp2.
.br
:p.
:lm margin=6.
.br
       bBloque &eq. &lbrc.&splitvbar.arg1&comma. arg2&splitvbar. QOUT&lpar. arg1+arg2&rpar. &rbrc.
.br
       EVAL&lpar. bBloque&comma. &cdq.Harbour&cdq.&comma. &cdq. es fabuloso&cdq.&rpar.
.br
.br
.br
:hp2.Tests:ehp2.
.br
:p.
:lm margin=6.
.br
      Ver ejemplos.
.br
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin es 100 % compatible con CA&minus.Clipper.
.br
.br
:hp2.Platforms:ehp2.
.br
:p.
:lm margin=6.
:p.Todas
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.La librera es vm
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=19.AEVAL():elink.
.br
:link reftype=hd res=22.DBEVAL():elink.
.br
:h2 id=DOCUY res=86.Recolector de memoria
:i2 refid=DOCUMX.RECOLECTOR DE MEMORIA
:p.Recolector de memoria
.br
.br
:hp2.Lame con las caractersticas de la recoleccion de memoria en Harbour.:ehp2.
.br
:p.
:lm margin=6.
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.El recolector de memoria &lpar.garbage collector&rpar. usa la siguiente lgica&colon.  &minus. primero recolectar todas las ubicaciones de memoria que puedan  constituirse en &cdq.basura&cdq.  &minus. luego inspeccionar todas las
variables&comma. por si esos bloques estn  todava referenciados.
.br
:p.Note que slo arrays&comma. objetos y bloques de cdigo son recolectados  porque esos son los nicos tipos de datos que pueden causar&colon.  auto&minus.referencias  &lpar.a&lbrk.1&rbrk..&colon.&eq.a&rpar.   referencias
circulares&colon.  &lpar.a&lbrk.1&rbrk..&colon.&eq.b&semi. b&lbrk.1&rbrk..&colon.&eq.c&semi. c&lbrk.1&rbrk..&colon.&eq.a&rpar.  que no pueden ser apropiadamente desasignadas por un simple conteo  de refere
ncia.
.br
:p.Como todas las variables en Harbour son almacenadas dentro de algunas  tablas disponibles &lpar.eval stack&comma. tabla de memvars y array de variables  estticas&rpar.&comma. entonces chequear si la referencia es todava activa
es  bastante fcil y no requiere ningn tratamiento especial durante la  la asignacin de memoria. Adicionalmente el recolector de memoria  inspecciona algunos datos internos usados por la implementacin de  objetos de Harbour
que tambin almacena algunos valores que pueden  contener referencias de memoria. Estos datos son usados para inicia&minus.  lizar variables de instancia de la clase&comma. y son almacenadas en  variables compartidas por la
clase.
.br
:p.En casos especiales cuando el valor de una variable de Harbour es  almacenada internamente en algn area esttica &lpar.a nivel de lenguaje C   asembler&rpar.&comma. por ejemplo SETKEY&lpar.&rpar. almacena bloques de cdigo que
sern evaluados caundo se presione una tecla&comma. el recolector de  memoria no ser capaz de inspecionar esos valores porque este no  conoce su ubicacin. Esto podra ocasionar que algunos bloques de  memoria sean liberados
prematuramente. Para prevenir la prematura  desasignacin de esos bloques ellos deben ser bloqueados para el  recolector de memoria.  Para ello se definen distintos estados del bloque de memoria&colon.  #define
HB&us.GC&us.UNLOCKED    0  &slash.* desbloqueado    *&slash.  #define HB&us.GC&us.LOCKED      1  &slash.* No recolectar el bloque de memoria *&slash.  #define HB&us.GC&us.USED&us.FLAG   2  &slash.* bit para la bandera
usado&slash.sin uso  *&slash.
.br
:p.El bloque de memoria puede ser bloqueado con hb&us.gcLockItem&lpar.&rpar.&comma. mtodo  recomendado si un tem de estructura es usado  la funcin hb&us.gcLock&lpar.&rpar.  un puntero directo a memoria es usado.  El bloque de
memoria puede ser desbloqueado por hb&us.gcUnlockItem&lpar.&rpar.   hb&us.gcUnlock&lpar.&rpar..
.br
:p.Ntese sin embargo que todas las variables pasadas a una funcin de  bajo nivel son pasadas mediante la pila de evaluacin &lpar.eval stack&rpar.&comma.  as ellas no necesitan bloquearse durante la llamada a la funcin.  El
bloque puede ser requerido&comma. si un valor pasado es copiado dentro  de algn area esttica para hacerla disponible para otras funciones  de bajo nivel&comma. llamadas despus de la salida de la funcin que  almacena el valor.
Esto es requerido porque el valor es removido de  la pila de evaluacin despus de la llamada a la funcin y esta no  puede seguir siendo referenciada por otras variables.
.br
:p.Sin embargo la inspeccin de todas las variables puede ser una  operacin de un gran consumo de tiempo. Esto requiere que todos los  arrays asignados tengan que ser recorridos a travs de todos sus  elementos para encontrar ms
arrays.  Tambin todos los bloques de cdigo son inspecionados&comma. en busca de  variables locales separadas que ellos estan referenciando. Por esta  esta razn&comma. la busqueda por bloques de memoria no referenciados es
realizada durante los estados inactivos.
.br
:p.El estado inactivo es el estado cuando no hay un cdigo real de la  aplicacin ejecutndose. Por ejemplo&comma. el cdigo del usuario es  detenido durante 0.1 segundo por INKEY&lpar.0.1&rpar. &minus. Harbour esta chequeando  slo
el teclado durante este tiempo. Esto deja sin embargo suficiente  tiempo para muchas otras tareas en segundo plano. Una de esas tareas  en segundo plano&comma. puede ser la bsqueda de bloques de mem
oria no  referenciados.
.br
:p.Asignando memoria
:p.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.
.br
:p.El recolector de memoria&comma. recoge bloques de memoria asignados con  llamadas a la funcin hb&us.gcAlloc&lpar.&rpar..   La memoria asignada por  hb&us.gcAlloc&lpar.&rpar. debera ser liberada con la funcin
hb&us.gcFree&lpar.&rpar..
.br
.br
:p.Bloqueando memoria
:p.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.
.br
:p.La memoria asignada con hb&us.gcAlloc&lpar.&rpar. debera ser bloqueada para  prevenir una automtica liberacin como un puntero de memoria si no  es almacenado dentro de una variable a nivel de Harbour. Todos los  valores de
Harbour &lpar.items&rpar.&comma. almacenados internamente en reas  estticas de lenguaje C deben ser bloqueadas.  Vea hb&us.gcLockItem&lpar.&rpar. y hb&us.gcUnlockItem&lpar.&rpar. para ms informacin.
.br
.br
:p.La recolecin de memoria
:p.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.
.br
:p.Durante la bsqueda de memoria no referenciada&comma. el recolector de  memoria &lpar.RM&rpar. est usando un algoritmo llamado &cdq.mark &amp. sweep&cdq.&comma. marcar  y barrer. Este es realizado en tres etapas&colon.
.br
:p.1&rpar. Marcar todos los bloques asignados por el RM con un bandera&colon.  &cdq.sin uso&cdq.
.br
:p.2&rpar. barrer &lpar.buscar&rpar. todos los lugares conocidos y limpiar las banderas  sin uso por los bloques de memoria que son referenciados all&semi.
.br
:p.3&rpar. finalizar recolectando por desasignacin de todos los bloques de  memoria que an estan marcados como sin uso y que no estn bloqueados.
.br
:p.Para acelerar las cosas un poco&comma. la etapa de marca es simplificada  por la inversin del significado de la bandera &cdq.sin uso&cdq.. Despus de  la desasignacin de los bloques sin uso&comma. todos los bloques todava
activos son marcados con la bandera &cdq.usado&cdq. as nosotros podemos  invertir el significado de esta bandera al estado &cdq.sin uso&cdq. en la  prxima recolecin  Todos los bloques de memoria nuevos  sin bloquear son
automticamente  marcados como &cdq.sin uso&cdq. usando la bandera actual&comma. lo cual asegura que  todos los bloques de memoria son marcados con la misma bandera antes  de que la etapa de barrido comience.
.br
:p.Ver hb&us.gcCollectAll&lpar.&rpar. y hb&us.gcItemRef&lpar.&rpar.
.br
.br
:p.Llamando al recolector de memoria desde cdigo Harbour
:p.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.
&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.&minus.
.br
:p.El RM puede ser llamado directamente desde un programa en Harbour.  Esto es til en situaciones donde no hay estados inactivos disponibles   la aplicacin esta trabajando en un bucle sin interaccin con el  usuario y hay muchas
asignaciones de memoria.  Vea HB&us.GCALL&lpar.&rpar. por una explicacin de como llamar a esta funcin  desde el cdigo de Harbour.
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=87.HB_GCALLOC():elink.
.br
:link reftype=hd res=88.HB_GCFREE():elink.
.br
:link reftype=hd res=89.HB_GCLOCKITEM():elink.
.br
:link reftype=hd res=90.HB_GCUNLOCKITEM():elink.
.br
:link reftype=hd res=91.HB_GCCOLLECTALL():elink.
.br
:link reftype=hd res=92.HB_GCITEMREF():elink.
.br
:link reftype=hd res=93.HB_GCALL():elink.
.br
:link reftype=hd res=94.HB_IDLESTATE():elink.
.br
:h1 RECOY.RECOLECTOR DE MEMORIA
:h2  res=87.hb_gcAlloc()
:i1 id=RECOLX.RECOLECTOR DE MEMORIA
:i2 refid=RECOLX.HB_GCALLOC()
:p.hb&us.gcAlloc&lpar.&rpar.
.br
.br
:hp2.Asigna memoria que ser recolectada por el recolector de memoria.:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.#include <hbapi.h>:ehp2.
:p.:hp2.void *hb&us.gcAlloc&lpar. ULONG ulSize&comma. HB&us.GARBAGE&us.FUNC&us.PTR pCleanupFunc &rpar.&semi.:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<ulSize> es el tamao solicitado del bloque de memoria.
.br
:p.<pCleanupFunc> es un Puntero a la funcin HB&us.GARBAGE&us.FUNC que ser  llamada directamente antes de la liberacin del bloque de memoria  sin uso  NULL. Esta funcin debera liberar toda otra memoria  asignada y almacenada
dentro del bloque de memoria.  Por ejemplo&comma. esta libera todos los items almacenados dentro del array.  La funcin recibe un slo parmetro&colon. el puntero a la memoria asignada  por hb&us.gcAlloc&lpar.&rpar..
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.Devuelve un puntero a la memoria asignada  esta generar un error  interno irrecuperable.
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.hb&us.gcAlloc&lpar.&rpar. es usada para asignar la memoria que ser rastreada por  el RM. Este permite una apropiada liberacin de memoria en el caso  de variables auto&minus.referenciadas  con referencias cruzadas a nivel de
Harbour.  La memoria asignada con esta funcin debera ser liberada con la  funcin hb&us.gcFree&lpar.&rpar.  esta ser automticamente desasignada por el  RM si no esta bloq
ueada  si no esta referenciada por alguna  variable a nivel de Harbour.
.br
.br
:hp2.Examples:ehp2.
.br
:p.
:lm margin=6.
.br
      Vea  ..&slash.source&slash.vm&slash.arrays.c
.br

.br
     PHB&us.BASEARRAY pArr &eq. &lpar.PHB&us.BASEARRAY&rpar. hb&us.gcAlloc&lpar. sizeof&lpar. HB&us.BASEARRAY&rpar.&comma.
.br
                                                  hb&us.arrayReleaseGarbage &rpar.&semi.
.br
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Not Started
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin es una extensin de Harbour.
.br
.br
:hp2.Platforms:ehp2.
.br
:p.
:lm margin=6.
:p.Todas
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.Archivo fuente&colon. ..&slash.source&slash.vm&slash.garbage.c
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=88.HB_GCFREE():elink.
.br
:link reftype=hd res=89.HB_GCLOCKITEM():elink.
.br
:link reftype=hd res=90.HB_GCUNLOCKITEM():elink.
.br
:h2 id=RECOY res=88.hb_gcFree()
:i2 refid=RECOLX.HB_GCFREE()
:p.hb&us.gcFree&lpar.&rpar.
.br
.br
:hp2.Libera la memoria que fu asignada con hb&us.gcAlloc&lpar.&rpar..:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.void hb&us.gcFree&lpar. void *pMemoryPtr &rpar.&semi.:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<pMemoryPtr> es el puntero a la memoria a liberar. Este puntero de  memoria debe ser asignado con la funcin hb&us.gcAlloc&lpar.&rpar..
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.Nada.
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.La funcin hb&us.gcFree&lpar.&rpar. es usada para liberar la memoria que fu  asignada con la funcin hb&us.gcAlloc&lpar.&rpar..
.br
.br
:hp2.Examples:ehp2.
.br
:p.
:lm margin=6.
.br
      Vea ..&slash.source&slash.vm&slash.arrays.c
.br
      hb&us.gcFree&lpar. &lpar.void *&rpar. pBaseArray &rpar.&semi.  &slash.&slash. puntero al array a liberar
.br
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Not Started
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin es una extensin de Harbour.
.br
.br
:hp2.Platforms:ehp2.
.br
:p.
:lm margin=6.
:p.Todas
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.Archivo fuente&colon. ..&slash.source&slash.vm&slash.garbage.c
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=87.HB_GCALLOC():elink.
.br
:link reftype=hd res=89.HB_GCLOCKITEM():elink.
.br
:link reftype=hd res=90.HB_GCUNLOCKITEM():elink.
.br
:h2 id=RECOY res=89.hb_gcLockItem()
:i2 refid=RECOLX.HB_GCLOCKITEM()
:p.hb&us.gcLockItem&lpar.&rpar.
.br
.br
:hp2.Bloquea la memoria para prevenir la desasignacin por el RM.:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.void hb&us.gcLockItem&lpar. HB&us.ITEM&us.PTR pItem &rpar.&semi.:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<pItem> es el puntero a la estructura item que ser bloqueada.  El item pasado puede ser de cualquier tipo de datos&comma. aunque arrays  objetos y bloques de cdigos son bloqueados solamente. Otros tipos de  datos no necesitan
bloqueo as que ellos son simplemente ignorados.
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.Nada.
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.La funcin hb&us.gcLockItem&lpar.&rpar. es usada para bloquear el puntero de memoria  almacenado en la estructura item pasada. Este suprime la liberacin  de memoria si el RM no encuentra alguna referencia a este puntero  El RM
almacena un contador de bloqueo y cada llamada a esta funcin  incrementa el contador. El item es bloqueado si el contador es mayor  que cero.
.br
.br
:hp2.Examples:ehp2.
.br
:p.
:lm margin=6.
.br
      Vea ..&slash.source&slash.rtl&slash.setkey.c
.br
      &slash.&slash. bloquea un codeblock para prevenir la liberacin por el RM
.br
      hb&us.gcLockItem&lpar. sk&us.list&us.tmp&minus.> pAction &rpar.&semi.
.br
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Not Started
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin es una extensin de Harbour.
.br
.br
:hp2.Platforms:ehp2.
.br
:p.
:lm margin=6.
:p.Todas
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.Archivo fuente&colon. ..&slash.source&slash.vm&slash.garbage.c
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=87.HB_GCALLOC():elink.
.br
:link reftype=hd res=88.HB_GCFREE():elink.
.br
:link reftype=hd res=90.HB_GCUNLOCKITEM():elink.
.br
:h2 id=RECOY res=90.hb_gcUnlockItem()
:i2 refid=RECOLX.HB_GCUNLOCKITEM()
:p.hb&us.gcUnlockItem&lpar.&rpar.
.br
.br
:hp2.Desbloquea la memmoria para prevenir la liberacin por el RM:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.void hb&us.gcUnlockItem&lpar. HB&us.ITEM&us.PTR pItem &rpar.&semi.:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<pItem> es el puntero a la estructura item que ser bloqueada.  El item pasado puede ser de cualquier tipo de datos&comma. aunque arrays  objetos y bloques de cdigos son bloqueados solamente. Otros tipos de  datos no necesitan
bloqueo as que ellos son simplemente ignorados.
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.Nada.
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.La funcin hb&us.gcUnlockItem&lpar.&rpar. es usada para desbloquear el puntero de  memoria almacenado en la estructura item pasada&comma. que fu previamente  bloqueada con una llamada a hb&us.gcLockItem&lpar.&rpar.. Esto permite
liberar la  memoria durante la recoleccin de memoria sin uso si el RM no encuentra  ninguna referencia a este puntero. El RM almacena el contador de  bloqueo&comma. cada llamda a esta funcin decrementa el contador.  Esta
funcin no libera la memoria almacenada dentro del item&comma. la  memoria debe ser desasignada sin embargo durante la recolecin de  memoria sin uso ms cercana si el contador de bloqueo es igual a cero  y el puntero de memoria
no es referenciado por ninguna variable a  nivel de Harbour.
.br
.br
:hp2.Examples:ehp2.
.br
:p.
:lm margin=6.
.br
      Vea ..&slash.source&slash.rtl&slash.setkey.c
.br
      hb&us.gcUnlockItem&lpar. sk&us.list&us.tmp&minus.> pAction &rpar.&semi.  &slash.&slash. libera el item
.br
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Not Started
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin es una extensin de Harbour.
.br
.br
:hp2.Platforms:ehp2.
.br
:p.
:lm margin=6.
:p.Todas
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.Archivo fuente&colon. ..&slash.source&slash.vm&slash.garbage.c
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=87.HB_GCALLOC():elink.
.br
:link reftype=hd res=88.HB_GCFREE():elink.
.br
:link reftype=hd res=89.HB_GCLOCKITEM():elink.
.br
:h2 id=RECOY res=91.hb_gcCollectAll()
:i2 refid=RECOLX.HB_GCCOLLECTALL()
:p.hb&us.gcCollectAll&lpar.&rpar.
.br
.br
:hp2.Examina todos los bloques de memoria y libera la memoria sin uso.:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.void hb&us.gcCollectAll&lpar. void &rpar.&semi.:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.Ninguno.
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.Nada.
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin examina la pila de evaluacin&comma. las tablas de memvars&comma.  el array de variables estticas y las tablas de clases creadas en  busca de bloques de memoria referenciados. Despus de examinar todos  los bloques
de memoria sin uso y los bloques que no estan bloqueados&comma.  son liberados.
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Not Started
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin es una extensin de Harbour.
.br
.br
:hp2.Platforms:ehp2.
.br
:p.
:lm margin=6.
:p.Todas
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.Archivo fuente&colon. ..&slash.source&slash.vm&slash.garbage.c
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=87.HB_GCALLOC():elink.
.br
:link reftype=hd res=88.HB_GCFREE():elink.
.br
:link reftype=hd res=89.HB_GCLOCKITEM():elink.
.br
:link reftype=hd res=90.HB_GCUNLOCKITEM():elink.
.br
:h2 id=RECOY res=92.hb_gcItemRef()
:i2 refid=RECOLX.HB_GCITEMREF()
:p.hb&us.gcItemRef&lpar.&rpar.
.br
.br
:hp2.Marca la memoria para prevenir la desasignacin por el RM.:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.void hb&us.gcItemRef&lpar. HB&us.ITEM&us.PTR pItem &rpar.&semi.:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<pItem> es el puntero a la estructura item que ser examinada.  El item pasado puede ser de cualquier tipo de datos&comma. aunque arrays  objetos y bloques de cdigos son bloqueados solamente. Otros tipos de  datos no necesitan
bloqueo as que ellos son simplemente ignorados.
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.Nada.
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.El recolector de memoria usa la funcin hb&us.gcItemRef&lpar.&rpar. durante la  inspeccin de punteros de memoria referenciados. Esta funcin chequea  el tipo del item pasado y examina recursivamente todos los otros  bloques de
memoria referenciados por este item&comma. si ste es un array  un objeto  un bloque de cdigo
.br
:p.NOTA&colon. Esta funcin es reservada para el recolector de memoria &lpar.RM&rpar.  solamente. Esta NO debe ser llamada desde el cdigo del usuario  llamarla puede causar resultados impredecibles &lpar.bloques de  memoria
referenciados por el item pasado pueden ser liberados  prematuramente durante la recolecin de memoria ms cercana&rpar..
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Not Started
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin es una extensin de Harbour.
.br
.br
:hp2.Platforms:ehp2.
.br
:p.
:lm margin=6.
:p.Todas
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.Archivo fuente&colon. ..&slash.source&slash.vm&slash.garbage.c
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=87.HB_GCALLOC():elink.
.br
:link reftype=hd res=88.HB_GCFREE():elink.
.br
:link reftype=hd res=89.HB_GCLOCKITEM():elink.
.br
:link reftype=hd res=90.HB_GCUNLOCKITEM():elink.
.br
:h2 id=RECOY res=93.HB_GCALL()
:i2 refid=RECOLX.HB_GCALL()
:p.HB&us.GCALL&lpar.&rpar.
.br
.br
:hp2.Inspeciona la memoria y libera todos los bloques de memoria sin uso.:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.HB&us.GCALL&lpar.&rpar.:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.Ninguno
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.NIL
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin libera todos los bloques de memoria que son considerados  como &cdq.basura&cdq..
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
      Harbour
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin es una extensin de Harbour.
.br
.br
:hp2.Platforms:ehp2.
.br
:p.
:lm margin=6.
:p.Todas
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.Archivo fuente&colon. ..&slash.source&slash.vm&slash.garbage.c
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=91.HB_GCCOLLECTALL():elink.
.br
:h1 SETY.SET API
:h2  res=95.hb_setInitialize ()
:i1 id=SET AX.SET API
:i2 refid=SET AX.HB_SETINITIALIZE ()
:p.hb&us.setInitialize &lpar.&rpar.
.br
.br
:hp2.:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.Prototipo C:ehp2.
.br
:p.:hp2.#include <hbset.h>:ehp2.
:p.:hp2.hb&us.setInitialize&lpar. void &rpar. &minus.&minus.> void:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
.br
.br
:hp2.Examples:ehp2.
.br
:p.
:lm margin=6.
.br
.br

.br
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.El cumplimiento no es aplicable a las llamadas de API.
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.La biblioteca es rtl
.br
.br
:hp2.Platforms:ehp2.
.br
:p.
:lm margin=6.
:p.Todas
:h2 id=SETY res=96.hb_setRelease()
:i2 refid=SET AX.HB_SETRELEASE()
:p.hb&us.setRelease&lpar.&rpar.
.br
.br
:hp2.:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.Prototipo C:ehp2.
.br
:p.:hp2.#include <hbset.h>:ehp2.
:p.:hp2.hb&us.setRelease&lpar. void &rpar. &minus.&minus.> void:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
.br
.br
:hp2.Examples:ehp2.
.br
:p.
:lm margin=6.
.br
.br

.br
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.El cumplimiento no es aplicable a las llamadas de API.
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.La biblioteca es rtl
.br
.br
:hp2.Platforms:ehp2.
.br
:p.
:lm margin=6.
:p.Todas
:h1 NATIY.NATION
:h2  res=97.HB_LANGSELECT()
:i1 id=NATIOX.NATION
:i2 refid=NATIOX.HB_LANGSELECT()
:p.HB&us.LANGSELECT&lpar.&rpar.
.br
.br
:hp2.Selecciona un mdulo de mensajes especfico a una nacionalidad.:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.HB&us.LANGSELECT&lpar.<cNuevoLeng>&rpar.   &minus.&minus.> cViejoLeng:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<cNuevoLeng>  El cdigo de identificacin del mdulo de idioma del pas  Los valores posibles para <cNuevoLeng> estan mostrados abajo&comma. tal como  estn definidos en la librera de Lenguajes&comma. ordenados por idioma.
.br
:table cols='18  9 16'.
:row.
:c.&lt.cNuevoLeng&gt.
:c.Idioma
:c.Cdigo de Pgina
:row.
:c.EU
:c.Vasco
:c.850
:row.
:c.CS852
:c.Checo
:c.852
:row.
:c.CSISO
:c.Checo
:c.ISO-8859-2
:row.
:c.CSKAM
:c.Checo
:c.KAM
:row.
:c.CA
:c.Cataln
:c.850
:row.
:c.EN
:c.Ingls
:c.437
:row.
:c.FR
:c.Francs
:c.850
:row.
:c.GL
:c.Gallego
:c.850
:row.
:c.HE862
:c.Hebreo
:c.862
:row.
:c.HEWIN
:c.Hebreo
:c.1255
:row.
:c.HU852
:c.Hungaro
:c.852
:row.
:c.HUCWI
:c.Hungaro
:c.CWI-2
:row.
:c.HUWIN
:c.Hungaro
:c.Windows-1
:row.
:c.IS85
:c.Islands
:c.850
:row.
:c.PT
:c.Portugus
:c.850
:row.
:c.RO
:c.Rumano
:c.852
:row.
:c.SRISO
:c.Serbio
:c.ISO-8859-2
:row.
:c.SR852
:c.Serbio
:c.852
:row.
:c.ES
:c.Espaol
:c.850
:etable.
.br
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.<cViejoLeng>   El anterior identificador de Lenguaje
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin establece un mdulo de lenguaje o idioma para las  advertencias internas&comma. mensajes NatMsg y errores internos que utilizan  nombres de fechas&comma. das&comma. meses&comma. etc. Cuando una IDentificacin de
Lenguaje es elegida todos los mensajes son mostrados de acuerdo al  actual idioma&comma. hasta que otro sea seleccionado&comma.  el programa termine.  La ID son dos letras que establecen la correspondencia con un idioma  dado de
acuerdo a una tabla.
.br
:p.Nota&colon. La tabla que se muestra arriba puede no estar completa.
.br
.br
:hp2.Examples:ehp2.
.br
:p.
:lm margin=6.
.br
      * El siguiente ejemplo cambia el mdulo de idioma por defecto&comma. y luego
.br
        muestra por pantalla la ID del mdulo de lenguaje&comma. el nombre del da
.br
        de la semana y el mes en varios idiomas.
.br

.br
        REQUEST HB&us.LANG&us.PT
.br
        REQUEST HB&us.LANG&us.RO
.br
        REQUEST HB&us.LANG&us.ES
.br
        LOCAL nViejo
.br

.br
        HB&us.LANGSELECT&lpar.&cdq.PT&cdq.&rpar.      &slash.&slash. el idioma por defecto es ahora Portugus
.br
        ? &cdq.La nueva ID de idioma elegida es &cdq.&comma. HB&us.LANGSELECT&lpar.&rpar.   &slash.&slash. PT
.br
        ? CDOW&lpar. DATE&lpar.&rpar. &rpar.
.br
        ? CMONTH&lpar. DATE&lpar.&rpar. &rpar.
.br

.br
        nViejo &colon.&eq. HB&us.LANGSELECT&lpar.&cdq.RO&cdq.&rpar.  &slash.&slash. el idioma por defecto es Romano
.br
        ? &cdq.La vieja ID de idioma elegida era &cdq.&comma. nViejo            &slash.&slash. PT
.br
        ? &cdq.La nueva ID de idioma elegida es  &cdq.&comma. HB&us.LANGSELECT&lpar.&rpar.   &slash.&slash. RO
.br
        ? CDOW&lpar. DATE&lpar.&rpar. &rpar.
.br
        ? CMONTH&lpar. DATE&lpar.&rpar. &rpar.
.br

.br
        HB&us.LANGSELECT&lpar.&cdq.ES&cdq.&rpar.         &slash.&slash. el idioma por defecto es ahora Espaol
.br
        ? &cdq.La nueva ID de idioma elegida es  &cdq.&comma. HB&us.LANGSELECT&lpar.&rpar.   &slash.&slash. ES
.br
        ? CDOW&lpar. DATE&lpar.&rpar. &rpar.
.br
        ? CMONTH&lpar. DATE&lpar.&rpar. &rpar.
.br

.br
.br
.br
:hp2.Tests:ehp2.
.br
:p.
:lm margin=6.
.br
      Vea ..\tests\langapi.prg
.br
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin es una Extensin de Harbour.
.br
.br
:hp2.Platforms:ehp2.
.br
:p.
:lm margin=6.
:p.Dos&comma. Win32&comma. OS&slash.2
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.La librera asociada es rtl
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=98.HB_LANGNAME():elink.
.br
:link reftype=hd res=99.NATIONMSG():elink.
.br
:h2 id=NATIY res=98.HB_LANGNAME()
:i2 refid=NATIOX.HB_LANGNAME()
:p.HB&us.LANGNAME&lpar.&rpar.
.br
.br
:hp2.Retorna el nombre del mdulo actual de lenguaje en uso.:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.HB&us.LANGNAME&lpar.&rpar.   &minus.&minus.> cNombreLenguaje:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.None.
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.HB&us.LANGNAME&lpar.&rpar. retorna <cNombreLenguaje>&comma. el nombre del idioma en uso.
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin describe el nombre del idioma  lenguaje correspondiente  al que existe por defecto  ha sido establecido por HB&us.LANGSELECT&lpar.&rpar..
.br
.br
:hp2.Examples:ehp2.
.br
:p.
:lm margin=6.
.br
      * El siguiente ejemplo cambia el mdulo de idioma por defecto&comma. y luego
.br
        muestra por pantalla la ID del mdulo de lenguaje&comma. el idioma asociado
.br
        a esa ID. y el da de la semana y el mes en varios idiomas.
.br

.br
        REQUEST HB&us.LANG&us.PT
.br
        REQUEST HB&us.LANG&us.ES
.br

.br
        HB&us.LANGSELECT&lpar.&cdq.PT&cdq.&rpar.     &slash.&slash. el idioma por defecto es ahora Portugus
.br
        ? &cdq.El idioma actual es &cdq.&comma. HB&us.LANGNAME&lpar.&rpar.               &slash.&slash. Portugus
.br
        ? &cdq.La nueva ID de idioma elegida es &cdq.&comma. HB&us.LANGSELECT&lpar.&rpar.   &slash.&slash. RO
.br
        ? CDOW&lpar. DATE&lpar.&rpar. &rpar.
.br
        ? CMONTH&lpar. DATE&lpar.&rpar. &rpar.
.br

.br
        HB&us.LANGSELECT&lpar.&cdq.ES&cdq.&rpar.       &slash.&slash. el idioma por defecto es ahora Espaol
.br
        ? &cdq.El idioma actual es &cdq.&comma. HB&us.LANGNAME&lpar.&rpar.         &slash.&slash. Espaol
.br
        ? CDOW&lpar. DATE&lpar.&rpar. &rpar.
.br
        ? CMONTH&lpar. DATE&lpar.&rpar. &rpar.
.br
.br
.br
:hp2.Tests:ehp2.
.br
:p.
:lm margin=6.
.br
      Vea ..\tests\langapi.prg
.br
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin es una Extensin de Harbour.
.br
.br
:hp2.Platforms:ehp2.
.br
:p.
:lm margin=6.
:p.Dos&comma. Win32&comma. OS&slash.2
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.La librera asociada es lang  Nota&colon. el nombre de la extensin de la librera&comma. puede cambiar con el  sistema operativo
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=97.HB_LANGSELECT():elink.
.br
:link reftype=hd res=99.NATIONMSG():elink.
.br
:h1 CADEY.CADENAS
:h2  res=100.MEMOTRAN()
:i1 id=CADENX.CADENAS
:i2 refid=CADENX.MEMOTRAN()
:p.MEMOTRAN&lpar.&rpar.
.br
.br
:hp2.Reemplaza los retornos del carro&slash.nueva linea de una cadena:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.MEMOTRAN&lpar. <cCadena>&comma. <cDuro>&comma. <cBlando> &rpar. &minus.&minus.> <cCadenaConvertida>:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<cCadena> es la cadena de caracteres a convertir.
.br
:p.<cDuro> es el carcter para reemplazar los retornos de carro &cdq.duro&cdq..  Si no es especificado por defecto es el punto y coma.
.br
:p.<cBlando> es el cracter para reemplazar los retornos de carro &cdq.blandos&cdq.  Si no es especificado&comma. por defecto es un espacio en blanco.
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.MEMOTRAN&lpar.&rpar. retorna <cCadenaConvertida>&comma. la cadena transformada.
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin retorna una cadena donde los caracteres de retorno de  carro han sido convertidos a los caracteres especificados.
.br
.br
:hp2.Examples:ehp2.
.br
:p.
:lm margin=6.
.br
      * El siguiente ejemplo formatea un campo memo conteniendo un mensaje
.br
        de error en una cadena adecuada para ser enviada a la funcin ALERT&lpar.&rpar.
.br

.br
        cMensaje &eq. MEMOTRAN&lpar. Errores&minus.>MENSAJE &rpar.
.br
        ALERT&lpar. cMensaje&comma. aOpciones &rpar.
.br
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin es totalmente compatible con CA&minus.Clipper.
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.La librera asociada es rtl
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=101.HARDCR():elink.
.br
:link reftype=hd res=102.STRTRAN():elink.
.br
:h1 STRIY.STRINGS
:h2  res=101.HARDCR()
:i1 id=STRINX.STRINGS
:i2 refid=STRINX.HARDCR()
:p.HARDCR&lpar.&rpar.
.br
.br
:hp2.Reemplaza los CHR&lpar.141&rpar. por retornos de carro normal CHR&lpar.13&rpar.:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.HARDCR&lpar. <cCadena> &rpar. &minus.&minus.> <cCadenaConvertida>:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<cCadena> es la cadena de caracteres a convertir.
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.HARDCR&lpar.&rpar. retorna <cCadenaConvertida>&comma. la cadena transformada.
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin retorna una cadena&slash.memo donde los caracteres de retorno de  carro automaticos  &cdq.blandos&cdq. &lpar. CHR&lpar.141&rpar. &rpar. son convertidos a caracteres  de retorno de carro forzado  &cdq.duro&cdq.
CHR&lpar.13&rpar..
.br
.br
:hp2.Examples:ehp2.
.br
:p.
:lm margin=6.
.br
      * El siguiente ejemplo asigna a una variable de cadena&comma. el campo memo
.br
        NOTAS existente en la base Clientes&comma. transformado para mostrarlo por
.br
        pantalla.
.br
        cNotas &eq. HARDCR&lpar. Clientes&minus.>NOTAS &rpar.
.br
        ? cNotas
.br

.br
      * El siguiente ejemplo envia a la impresora el contenido de un campo
.br
        memo.
.br

.br
        SET DEVICE TO PRINTER
.br
        DEVPOS&lpar. nFil&comma. nCol&rpar.
.br
        DEVOUT&lpar. HARDCR&lpar. Clientes&minus.>NOTAS &rpar. &rpar.
.br

.br
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.Esta funcin es totalmente compatible con CA&minus.Clipper.
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.La librera asociada es rtl
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=100.MEMOTRAN():elink.
.br
:link reftype=hd res=102.STRTRAN():elink.
.br
:h1 ENTOY.ENTORNO
:h2  res=103.SETMODE()
:i1 id=ENTORX.ENTORNO
:i2 refid=ENTORX.SETMODE()
:p.SETMODE&lpar.&rpar.
.br
.br
:hp2.Cambia el modo de video a un nmero especificado de filas y columnas:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.SETMODE&lpar. <nFil>&comma. <nCol> &rpar. &minus.&minus.> lSatisfactorio:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<nFil> es el nmero de filas para el modo de video deseado.
.br
:p.<nCol> es el nmero de columnas para el modo de video deseado.
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.SETMODE&lpar.&rpar. devuelve verdadero si el cambio en el modo de video fue  satisfactorio&comma. de otra manera devuelve falso.
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.SETMODE&lpar.&rpar. es una funcin que cambia el modo de video &lpar.dependiendo de  la combination de tarjeta de video y monitor&rpar.&comma. para que coincida con  el nmero de filas y columnas especificado.  Ntese que slo
hay realmente unas pocas combinaciones de pares de  filas&slash.columnas que produzcan el cambio en el modo de video.  Los siguientes estan disponibles para D.O.S&colon.  12 filas x 40 columnas            12 filas x 80 columnas
25 filas x 40 columnas            25 filas x 80 columnas  28 filas x 40 columnas            28 filas x 80 columnas  50 filas x 40 columnas            43 filas x 80 columnas  50 filas x 80 columnas  Algunas modos slo estan
disponibles para monitor color y&slash.o VGA.  Cualquier cambio producido en el tamao de la pantalla es actualizado  en los valores devueltos por MAXROW&lpar.&rpar. y MAXCOL&lpar.&rpar..
.br
.br
:hp2.Examples:ehp2.
.br
:p.
:lm margin=6.
.br
     El primer ejemplo cambia al modo de visualizacion de 12 lineas&colon.
.br

.br
      IF SETMODE&lpar. 12&comma. 40&rpar.
.br
         ? &cdq.Oye hombre&comma. eres tu chicato ?&cdq.
.br
      ELSE
.br
         ? &cdq.Mam treme los anteojos !&cdq.
.br
      ENDIF
.br

.br
     El prximo ejemplo cambia al modo de visualizacion de 50 lineas&colon.
.br
      IF SETMODE&lpar. 50&comma. 80&rpar.
.br
         ? &cdq.Este maravilloso modo de video ha sido seteado&cdq.
.br
      ELSE
.br
         ? &cdq.Oye Manuel que este monitor no est hecho de goma !&cdq.
.br
      ENDIF
.br

.br
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.Algunos de estos modos no estan disponibles en Clipper
.br
.br
:hp2.Platforms:ehp2.
.br
:p.
:lm margin=6.
:p.DOS
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.El Achivo fuente es gtdos.c
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=104.MAXCOL():elink.
.br
:link reftype=hd res=105. MAXROW():elink.
.br
:euserdoc.
